/*
	$Id: auth.h,v 1.11 2008/08/09 09:21:37 alex Exp $
	auth.h --- header file for authentication
*/

#ifndef	Auth_Inc_Defined
#define	Auth_Inc_Defined

#define	EDB_AUTHENTICATION_TABLE		"edb_authentication"

#define	EDB_AUTHENTICATION_COLUMN_EID		"eid"
#define	EDB_AUTHENTICATION_COLUMN_EOID		"eoid"
#define	EDB_AUTHENTICATION_COLUMN_XML		"xml"

#define	EDB_AUTH_TABLE				"edb_auth"

#define	EDB_AUTH_INHERIT		0
#define	EDB_AUTH_PUBLIC		0
#define	EDB_AUTH_UNIVERSITY	1
#define	EDB_AUTH_USER		2
#define	EDB_AUTH_PERSONNEL	3
#define	EDB_AUTH_TEACHER	4
#define	EDB_AUTH_LIMITED		5
#define	EDB_AUTH_OWNER		6
#define	EDB_AUTH_STAFF		7

/* auth */
struct EDB_AUTH_INFO {
	struct EDB_BASE_INFO	base;
	eid_t	edb_eid;
	int	edb_type;
	utf8_t	*edb_pp;
	utf8_t	*edb_pps;
	utf8_t	*edb_ppo;
};
typedef	struct EDB_AUTH_INFO	* EdbAuthInfo;

int			edb_auth_check_user			__P((EdbContext, eid_t));
int			edb_auth_check_personnel		__P((EdbContext, eid_t));
int			edb_auth_check_teacher			__P((EdbContext, eid_t));

EdbAuthInfo	edb_auth_parse_xml				__P((EdbContext, xmlChar *));
utf8_t *		edb_auth_make_xml				__P((EdbContext, EdbAuthInfo));
EdbAuthInfo	edb_auth_new					__P((EdbContext, eid_t));
void			edb_auth_free					__P((EdbContext, EdbAuthInfo));
EdbAuthInfo	edb_auth_get_XMLDB			__P((EdbContext, eid_t, eoid_t));
eoid_t		edb_auth_put_XMLDB			__P((EdbContext, EdbAuthInfo));
int			edb_auth_delete_XMLDB			__P((EdbContext, eid_t, eoid_t));
int			edb_auth_put					__P((EdbContext, EdbAuthInfo, eid_t));
eoid_t		edb_auth_put_reldb				__P((EdbContext, EdbAuthInfo));
int			edb_auth_adjust				__P((EdbContext, EdbAuthInfo));
int			edb_auth_registered				__P((EdbContext, eid_t));
int			edb_auth_isStaff				__P((EdbContext, eid_t));
int			edb_auth_isOdin				__P((EdbContext, eid_t));
int			edb_auth_check				__P((EdbContext, eid_t, utf8_t *));
int			edb_auth_check_staff			__P((EdbContext, eid_t, utf8_t *));
int			edb_auth_check_Odin			__P((EdbContext, eid_t, utf8_t *));
int			edb_auth_make_pp				__P((EdbContext, utf8_t *, utf8_t *));
int			edb_auth_set					__P((EdbContext, eid_t, utf8_t *));
int			edb_auth_set_staff				__P((EdbContext, eid_t, utf8_t *));
int			edb_auth_set_Odin				__P((EdbContext, eid_t, utf8_t *));
int			edb_auth_delete				__P((EdbContext, eid_t));
int			edb_auth_delete_staff			__P((EdbContext, eid_t));
int			edb_auth_readable				__P((EdbContext, eid_t));
int			edb_auth_readable_table_for_all_tuples		__P((EdbContext, EdbTableInfo));
int			edb_auth_readable_table_column_for_all_tuples	__P((EdbContext, EdbTableInfo, EdbColumnInfo));
int			edb_auth_readable_TCD			__P((EdbContext, EdbTupleInfo, EdbTupleColumn, EdbDatum));
int			edb_auth_readable_tuple_column	__P((EdbContext, EdbTupleInfo, EdbColumnInfo));
int			edb_auth_creatable_tuple_column	__P((EdbContext, EdbTupleInfo, EdbColumnInfo));
int			edb_auth_writable_tuple_column	__P((EdbContext, EdbTupleInfo, EdbColumnInfo));
int			edb_auth_deletable_tuple_column	__P((EdbContext, EdbTupleInfo, EdbColumnInfo));
int			edb_auth_tuple_is_public_readable	__P((EdbContext, EdbTupleInfo, EdbColumnInfo));
int			edb_auth_readable_by			__P((EdbContext, eid_t, eid_t));
int			edb_auth_writable				__P((EdbContext, eid_t));
int			edb_auth_writable_by			__P((EdbContext, eid_t, eid_t));
int			edb_auth_deletable				__P((EdbContext, eid_t));
int			edb_auth_deletable_by			__P((EdbContext, eid_t, eid_t));
int			edb_auth_table_creatable			__P((EdbContext));
int			edb_auth_table_creatable_by		__P((EdbContext, eid_t));
int			edb_auth_column_creatable		__P((EdbContext, eid_t));
int			edb_auth_column_creatable_by		__P((EdbContext, eid_t, eid_t));
int			edb_auth_tuple_creatable			__P((EdbContext, eid_t));
int			edb_auth_tuple_creatable_by		__P((EdbContext, eid_t, eid_t));

utf8_t	*	edb_auth_string					__P((EdbContext, int, int));
utf8_t	*	edb_auth_xmlstring				__P((EdbContext, int, int));
int			edb_auth_xmlname_to_permission	__P((utf8_t *, int));

#if defined(Enable_AITUID)
int			edb_auth_UIDisAITUID			__P((char *));
int			edb_auth_check_by_aituid			__P((EdbContext, char *, char *));
#endif

#endif	/* Auth_Inc_Defined */

