/*
	$Id: base.h,v 1.9 2009/07/31 11:26:47 alex Exp $
	base.h --- base type definition
*/

#ifndef	Base_Inc_Defined
#define	Base_Inc_Defined

#include	<time.h>
#include	"edb/eid.h"

#define	EDB_BASE_EID			"eid"
#define	EDB_BASE_EOID		"eoid"
#define	EDB_BASE_MAPTO_EID	"mapto_eid"
#define	EDB_BASE_PARENT_EID	"parent_eid"
#define	EDB_BASE_MTIME		"mtime"
#define	EDB_BASE_AVAILABLE	"av"
#define	EDB_BASE_DATE_FROM	"date_from"
#define	EDB_BASE_DATE_TO	"date_to"
#define	EDB_BASE_CENSOR		"censor"
#define	EDB_BASE_OPERATOR	"op"
#define	EDB_BASE_OWNER		"owner"
#define	EDB_BASE_RDL		"rd"
#define	EDB_BASE_WRL		"wr"
#define	EDB_BASE_DEL		"de"

struct EDB_BASE_INFO {
	void		*dummy;		/* for delayed free */
	eid_t		eid;			/* EID */
	eoid_t	eoid;			/* EOID */
	eid_t		mapto;		/* mapto EID */
	eid_t		parent;		/* parent EID */
	time_t	mtime;		/* date_time */
	eid_t		op;			/* operator */
	int		censor;		/* censor */
	int		av;			/* available */
	int32_t	date_from;	/* available date from */
	int32_t	date_to;		/* available date to */
	eid_t		owner;		/* owner */
	int		rdl, wrl, del;	/* read/write/delete level */
};
typedef	struct EDB_BASE_INFO	*EdbBaseInfo;

#define	BaseEID(b)		((b)->eid)
#define	BaseEOID(b)		((b)->eoid)
#define	BaseMapto(b)		((b)->mapto)
#define	BaseParent(b)		((b)->parent)
#define	BaseMtime(b)		((b)->mtime)
#define	BaseOperator(b)	((b)->op)
#define	BaseAvail(b)		((b)->av)
#define	BaseDateFrom(b)	((b)->date_from)
#define	BaseDateTo(b)		((b)->date_to)
#define	BaseCensor(b)		((b)->censor)
#define	BaseOwner(b)		((b)->owner)
#define	BaseRead(b)		((b)->rdl)
#define	BaseWrite(b)		((b)->wrl)
#define	BaseDelete(b)		((b)->del)

/* base */
void			edb_base_init				__P((EdbContext, EdbBaseInfo));
int			edb_base_parse_xml			__P((EdbContext, EdbBaseInfo, xmlDocPtr, xmlNodePtr));
utf8_t	*	edb_base_make_xml			__P((EdbContext, EdbBaseInfo, int));
int			edb_base_make_query		__P((EdbContext, utf8_t **, utf8_t *));
int			edb_base_get_values		__P((EdbContext, EdbBaseInfo, void *));
Link			edb_base_get_lvalues		__P((EdbContext, EdbBaseInfo, Link));
void			edb_base_make_insert		__P((EdbContext, EdbBaseInfo, utf8_t **, utf8_t **));
void			edb_base_print_information	__P((EdbContext, EdbBaseInfo, int, Doc));
void			edb_base_print_in_xml		__P((EdbContext, EdbBaseInfo, int, Doc));

int			edb_base_compare			__P((EdbContext, EdbBaseInfo, EdbBaseInfo));

#endif	/* Base_Inc_Defined */

