/*
$Id: bitree.h,v 1.13 2008/08/09 09:21:37 alex Exp $
	bitree.h--- binary tree
*/

#ifndef	BiTreeIncDefined
#define	BiTreeIncDefined

#include	<sys/types.h>
#include	<stdint.h>
#include	"edb/unicode.h"

/* Binary Tree */
typedef	uint32_t 		BiTree_hint_t;
typedef	void		*	BiTree_obj_t;

struct BITREE {
	struct BITREE	*p, *n;	/* branch */
	int16_t		dp, dn;	/* depth of branch */
	BiTree_obj_t	obj;		/* object */
	BiTree_hint_t	hint;		/* hint */
};
typedef struct BITREE	*BiTree;

typedef int	(*BiTree_cmp_t)	__P((BiTree_obj_t, BiTree_obj_t));

int			bitree_num		__P((BiTree));
int			bitree_depth		__P((BiTree));
BiTree		bitree_add			__P((BiTree, BiTree_obj_t, BiTree_hint_t, BiTree_cmp_t, int (*) __P((BiTree_obj_t, BiTree_obj_t, void *)), void *));
BiTree		bitree_remove		__P((BiTree, BiTree_obj_t, BiTree_hint_t, BiTree_cmp_t, BiTree_obj_t *));
BiTree		bitree_rearrange	__P((BiTree));
BiTree_obj_t	bitree_search		__P((BiTree, BiTree_obj_t, BiTree_hint_t, BiTree_cmp_t));
BiTree		bitree_search_node	__P((BiTree, BiTree_obj_t, BiTree_hint_t, BiTree_cmp_t));
void			bitree_free		__P((BiTree, void (*) __P((BiTree_obj_t))));
void			bitree_free2		__P((BiTree, void (*) __P((void *, BiTree_obj_t)), void *));
int			bitree_callback		__P((BiTree, int (*) __P((BiTree_obj_t, void *)), void *));
int			bitree_callback_hint	__P((BiTree, int (*) __P((BiTree_obj_t, BiTree_hint_t, void *)), void *));
int			bitree_callback_node	__P((BiTree, int (*) __P((BiTree, void *)), void *));

/* dummy object for nothing object tree */
extern	BiTree_obj_t	bitree_dummy_object;

BiTree_hint_t	bitree_hint_ucs4str		__P((ucs4_t *));
BiTree_hint_t	bitree_hint_ucs4strcase	__P((ucs4_t *));
BiTree_hint_t	bitree_hint_str			__P((char	*));
BiTree_hint_t	bitree_hint_strcase		__P((char *));

/* compare for common strings */
int		bitree_compare_str			__P((BiTree_obj_t, BiTree_obj_t));
int		bitree_compare_strcase		__P((BiTree_obj_t, BiTree_obj_t));
int		bitree_compare_ucs4str		__P((BiTree_obj_t, BiTree_obj_t));
int		bitree_compare_ucs4strcase	__P((BiTree_obj_t, BiTree_obj_t));

/* utility macros */
#define	BiTreeAdd(t, o, h, c, e, d)		(t) = bitree_add((t), (o), (h), (c), (e), (d))
#define	BiTreeRemove(t, o, h, c, d)	(t) = bitree_remove((t), (o), (h), (c), (d))
#define	BiTreeRearrange(t)			(t) = bitree_rearrange((t))

#endif	/* BiTreeIncDefined */


