/*
	$Id: book.h,v 1.15 2004/03/29 12:49:43 alex Exp $
	book.h --- header file for book
*/

#ifndef	Book_Inc_Defined
#define	Book_Inc_Defined

#include	<stdio.h>
#include	"edb/look.h"
#include	"edb/print.h"

typedef	int	(*EdbBookPrintFunc)	__P((EdbPrint, EdbTupleInfo));

#define	CSV(ep)		if(PrintIsCSV((ep)))
#define	ITEMIZE(ep)	if(PrintIsITEMIZE((ep)))

#define	PLAIN(doc)	if(DocIsPLAIN(doc))
#define	HTML(doc)	if(DocIsHTML(doc))
#define	TeX(doc)		if(DocIsTeX(doc))
#define	pTeX(ep)		if(!PrintIsITEMIZE((ep)) && DocIsTeX((ep)->doc))
#define	LaTeX(ep)		if(PrintIsITEMIZE((ep)) && DocIsTeX((ep)->doc))
#define	NotLaTeX(ep)		if(!(PrintIsITEMIZE((ep)) && DocIsTeX((ep)->doc)))

#define	TEMPLATE(ti)	EDB_TUPLE_GET_template_table, (ti)

#define	TupleColumn_person_surname(ec, tuple)		edb_tuple_seek_column_by_xmlname((ec), (tuple), (utf8_t *)"person.surname")
#define	TupleColumn_person_middlename(ec, tuple)	edb_tuple_seek_column_by_xmlname((ec), (tuple), (utf8_t *)"person.middlename")
#define	TupleColumn_person_givenname(ec, tuple)	edb_tuple_seek_column_by_xmlname((ec), (tuple), (utf8_t *)"person.givenname")
#define	TupleColumn_person_degree(ec, tuple)		edb_tuple_seek_column_by_xmlname((ec), (tuple), (utf8_t *)"person.degree")
#define	TupleColumn_person_title(ec, tuple)			edb_tuple_seek_column_by_xmlname((ec), (tuple), (utf8_t *)"person.title")

#define	ALERT_COLOR		EP_ALERT_COLOR
#define	WARNING_COLOR	EP_WARNING_COLOR

#define	NUM_none	0
#define	NUM_Roman	1
#define	NUM_roman	2
#define	NUM_arabic	3

struct	PERIOD {
	int	date_from, date_to;
};

struct	BOOK {
	char	*dir;
	char	*name;
	char	*title;
	char	*subtitle;
	eid_t	organ_eid;
	int	number;
	struct PERIOD period;
	struct PERIOD thesis_period;
	struct SECTION	*part;
	EdbPrint	ep;
	EdbPrint	tmpep;
	FILE	*err_fp;
};
typedef struct BOOK	*Book;

struct	SECTION {
	char		*name;
	char		*title;
	eid_t		organ_eid;
	int		number;
	int		(*func) __P((Book, struct SECTION *));
	struct SECTION	*sec;
	eid_t		reid;
	eid_t		reid_old;

	/* for working */
	void		*data;
	int		layer;
	char		secno[BUFSIZ];
	Link		l_person;
	Link		l_article;
	Link		l_patent;
	Link		l_research;
	Link		l_eid;
	Link		l_info;
	Link		organ_eids;
	EdbPrint	ep;
};
typedef	struct SECTION	*Section;

Link	edb_book_get_tuple_list			__P((EdbContext, EdbTableInfo, char *));

int	edb_book_print_not_implement		__P((EdbPrint, EdbTupleInfo));
int	edb_book_person_is_teacher		__P((EdbContext, eid_t));
int	edb_book_print_text				__P((EdbPrint, EdbTupleInfo, char *, int, int, int));
int	edb_book_print_person_info_name	__P((EdbPrint, EdbTupleInfo, int, int));

Link	edb_book_get_eid_list			__P((EdbContext, eid_t, char *));
Link	edb_book_get_organ_lower_eids	__P((EdbContext, eid_t));
Link	edb_book_classify_into_organization	__P((EdbContext, Book, Link, char *, Section));
char *	edb_book_int2numstr			__P((char *, int, int));

int	edb_book_tuple_column_match_eid	__P((EdbContext, EdbTupleInfo, char *, eid_t));
int	edb_book_item_japanese			__P((EdbPrint, EdbTupleInfo, char *));

void	edb_book_begin_HTML			__P((EdbPrint, Book, char *));
void	edb_book_end_HTML				__P((EdbPrint, Book));

int	edb_make_book_section			__P((Book, Section));
int	edb_make_book					__P((EdbContext, Book, int, int, FILE *));

void	edb_book_print_initialize			__P((EdbPrint));
#endif	/* Book_Inc_Defined */

