/*
	$Id: catalogue.h,v 1.14 2005/07/19 12:41:57 alex Exp $
	catalogue.h --- header file for catalogue
*/

#ifndef	Catalogue_Inc_Defined
#define	Catalogue_Inc_Defined

#include	"edb/bitree.h"
#include	"edb/link.h"

struct EDB_CATALOGUE	{
	BiTree		bt;
	Link			link;
	Link			tail_hint;
};
typedef	struct EDB_CATALOGUE	*EdbCatalogue;

EdbCatalogue	edb_catalogue_new		__P((void));
void			edb_catalogue_free		__P((EdbCatalogue));
void			edb_catalogue_free2		__P((EdbCatalogue, void (*) __P((void *, BiTree_obj_t)), void *));
void			edb_catalogue_clean		__P((EdbCatalogue));
void			edb_catalogue_clean2	__P((EdbCatalogue, void (*) __P((void *, BiTree_obj_t)), void *));

int			edb_catalogue_append	__P((EdbCatalogue, eid_t, void *));
void	*		edb_catalogue_lookup	__P((EdbCatalogue, eid_t));
int			edb_catalogue_size		__P((EdbCatalogue));
int			edb_catalogue_callback	__P((EdbCatalogue, int (*) __P((BiTree_obj_t, void *)), void *));
EdbCatalogue	edb_catalogue_duplicate	__P((EdbCatalogue));
EdbCatalogue	edb_catalogue_merge	__P((EdbCatalogue, EdbCatalogue));

#define		ForCatalogueLink(l, ca)	ForLink((l), (ca)?((ca)->link):NULL)
#define		CatalogueObject(l)		((l)->d)

#endif	/* Catalogue_Inc_Defined */

