/*
	$Id: condition.h,v 1.10 2012/04/03 03:51:13 alex Exp alex $
	condition.h--- condition
*/

#ifndef	Condition_Inc_Defined
#define	Condition_Inc_Defined

#define	CONDITION_LOGIC_OR	0
#define	CONDITION_LOGIC_AND	1

#define	COND_NOP						1
#define	COND_PREFIX_TNAME				2
#define	COND_PREFIX_NOT					3
#define	COND_AVAILABLE					4
#define	COND_CONDITION					5
#define	COND_COLUMN					6
#define	COND_SKIP_NEXT					7

#define	ConditionTerminate					0
#define	ConditionNoOperation				COND_NOP
#define	ConditionPrefixTableName(s)			COND_PREFIX_TNAME, (s)
#define	ConditionPrefixNot					COND_PREFIX_NOT
#define	ConditionSkipNext					COND_SKIP_NEXT
#define	ConditionAvailable					COND_AVAILABLE
#define	ConditionCondition(s)					COND_CONDITION, (s)
#define	ConditionColumn(s)					COND_COLUMN, (s)

#define	COND_EID_MATCH					11
#define	COND_CATALOGUE_MATCH			12
#define	COND_EID_MATCH_NO_EXPAND		13
#define	COND_CATALOGUE_MATCH_NO_EXPAND	14

#define	ConditionEIDMatch(column, eid)			COND_EID_MATCH, (column), (eid)
#define	ConditionCatalogueMatch(column, ca)	COND_CATALOGUE_MATCH, (column), (ca)
#define	ConditionEIDMatchNoExpand(column, eid)	COND_EID_MATCH_NO_EXPAND, (column), (eid)
#define	ConditionCatalogueMatchNoExpand(column, ca)	COND_CATALOGUE_MATCH_NO_EXPAND, (column), (ca)

#define	COND_INT_EQ						21
#define	COND_INT_LE						22
#define	COND_INT_LT						23
#define	COND_INT_GE						24
#define	COND_INT_GT						25

#define	ConditionIntegerEQ(column, v)			COND_INT_EQ, (column), (int)(v)
#define	ConditionIntegerLE(column, v)			COND_INT_LE, (column), (int)(v)
#define	ConditionIntegerLT(column, v)			COND_INT_LT, (column), (int)(v)
#define	ConditionIntegerGE(column, v)			COND_INT_GE, (column), (int)(v)
#define	ConditionIntegerGT(column, v)			COND_INT_GT, (column), (int)(v)

#define	ConditionDateFrom(column, v)			ConditionIntegerGE((column), (v))

#define	COND_DATE2_OVERLAP				26
#define	ConditionDate2Overlap(column, v1, v2)	COND_DATE2_OVERLAP, (column), (int)(v1), (int)(v2)

#define	COND_REAL_EQ					31
#define	COND_REAL_LE					32
#define	COND_REAL_LT					33
#define	COND_REAL_GE					34
#define	COND_REAL_GT					35

#define	ConditionRealEQ(column, v)			COND_REAL_EQ, (column), (double)(v)
#define	ConditionRealLE(column, v)			COND_REAL_LE, (column), (double)(v)
#define	ConditionRealLT(column, v)			COND_REAL_LT, (column), (double)(v)
#define	ConditionRealGE(column, v)			COND_REAL_GE, (column), (double)(v)
#define	ConditionRealGT(column, v)			COND_REAL_GT, (column), (double)(v)

#define	COND_TEXT_EQ					41
#define	COND_REGEX_TEXT_EQ				42

#define	ConditionTextEQ(column, v)			COND_TEXT_EQ, (column), (utf8_t *)(v)
#define	ConditionRegexTextEQ(column, v)		COND_REGEX_TEXT_EQ, (column), (utf8_t *)(v)

utf8_t	*	edb_condition_make					__P((EdbContext, EdbTableInfo, int, ...));

struct EDB_MAPTO_CONDITION_CONTEXT {
	struct EDB_MAPTO_CONDITION_CONTEXT	*outer;
	EdbTableInfo		ti;		/* table */
	char				*tas;		/* Table as */
	EdbTupleInfo		tuple;	/* tuple */
	EdbTupleColumn	tc;		/* tuple */
	EdbColumnInfo		ci;		/* tuple */
	EdbDatum			sdatum;	/* super datum */
	EdbDatum			datum;	/* current datum */
};
typedef	struct EDB_MAPTO_CONDITION_CONTEXT	*EdbMaptoConditionContext;

// char *	edb_maplookup_candidate_classify_column	__P((EdbContext, EdbMaptoConditionContext, char *));
// char *	edb_maplookup_candidate_classify_value		__P((EdbContext, EdbMaptoConditionContext, char *));
char *	edb_maplookup_candidate_condition			__P((EdbContext, EdbMaptoConditionContext, EdbMapLookup));
char *	edb_maplookup_candidate_constraint			__P((EdbContext, EdbMaptoConditionContext, EdbMapLookup));
char *	edb_maplookup_candidate_classify			__P((EdbContext, EdbMaptoConditionContext, EdbMapLookup));

#endif /* Condition_Inc_Defined */
