/*
	$Id: doc.h,v 1.18 2008/08/09 09:21:37 alex Exp $
	doc.h --- document
*/

#ifndef	Doc_Inc_Defined
#define	Doc_Inc_Defined

struct DOC {	/* document */
#define	DocML_PLAIN		0
#define	DocML_XML		1
#define	DocML_HTML		2
#define	DocML_TeX		3
	int		dml;
#define	DocCodeset_Unicode	0	/* default */
#define	DocCodeset_Latin	1
	int		codeset;
	FILE		*fp;

	/* buffered string */
	ucs4_t	*buf;
	int		buf_size;
	int		buf_cp;

	int		inside;
	int		math;
	/* picture */
	int		(*picture_func)	__P((struct DOC *, char *, void *));
	void		*picture_udata;
	/* last output character */
	ucs4_t	lastc;
	char		*prefix;
#define	DOC_SPLIT_NONE	0
#define	DOC_SPLIT_SOME	1
#define	DOC_SPLIT_ALL	2
	int		split_mode;
};
typedef	struct DOC	*Doc;

/* doc */
Doc	doc_open		__P((int, char *, char *));
Doc	doc_sopen		__P((int));
int	doc_close		__P((Doc));
Doc	doc_fpopen	__P((int, FILE *));
void	doc_fpclose	__P((Doc));
Doc	doc_tmpopen	__P((int));
int	doc_flush		__P((Doc));

ucs4_t *	doc_ucs4_sgets	__P((Doc));
char *	doc_sgets			__P((Doc));
int		doc_sflush		__P((Doc));

int	doc_printf		__P((Doc, char *, ...));
int	doc_puts		__P((Doc, char *));
#if 0
int	doc_punctuation_puts		__P((Doc, char *));
#endif
int	doc_prefix_set		__P((Doc, char *));
int	doc_prefix_reset	__P((Doc));
int	doc_putc		__P((Doc, int));
int	doc_comment_printf		__P((Doc, char *, ...));
int	doc_text_puts	__P((Doc, char *));
int	doc_text_putc	__P((Doc, int));
int	doc_text_puts3	__P((Doc, char *, char *, char *));
int	doc_text_printf		__P((Doc, char *, ...));
void	doc_color_begin	__P((Doc, char *));
void	doc_color_end	__P((Doc));
void	doc_underline_begin	__P((Doc));
void	doc_underline_end	__P((Doc));
void	doc_put_datetime	__P((Doc, time_t));

#define	DocIsPLAIN(doc)	((doc)->dml == DocML_PLAIN)
#define	DocIsXML(doc)		((doc)->dml == DocML_XML)
#define	DocIsHTML(doc)	((doc)->dml == DocML_HTML)
#define	DocIsTeX(doc)		((doc)->dml == DocML_TeX)

#define	DocIsEnglish(doc)		((doc)->lang == DocLang_ENGLISH)
#define	DocIsJapanese(doc)		((doc)->lang == DocLang_JAPANESE)

#define	DocIsLatin(doc)		((doc)->charset_is_latin)

#endif	/* Doc_Inc_Defined */

