/*
	$Id: index.h,v 1.6 2009/07/31 11:26:47 alex Exp $
	index.h --- header file for index
*/

#ifndef	Index_Inc_Defined
#define	Index_Inc_Defined

#include	"edb/eid.h"
#include	"edb/base.h"
#include	"edb/link.h"

#define	EDB_EID_IS_TABLE		1
#define	EDB_EID_IS_COLUMN	2
#define	EDB_EID_IS_TUPLE		3

struct EDB_INDEX_INFO {
	struct EDB_BASE_INFO base;
	eid_t		teid;
	eid_t		*reids;	/* referred EID: if allocated, 0 terminated */
	eid_t		*peids;	/* referred and permed EID: if allocated, 0 terminated  */
};
typedef	struct EDB_INDEX_INFO	*EdbIndexInfo;

#define	EDB_INDEX_REF_EID_MARK	"E"
#define	EDB_INDEX_REF_PEID_MARK	"P"

EdbIndexInfo	edb_index_new		__P((EdbContext));
void			edb_index_free		__P((EdbContext, EdbIndexInfo));
EdbIndexInfo	edb_index_get		__P((EdbContext, eid_t));
int			edb_index_put		__P((EdbContext, EdbBaseInfo, int, eid_t, Link, Link));

struct EDB_INDEX_COUNT {
	int	avail;
	int	unavail;
};
typedef	struct EDB_INDEX_COUNT	*EdbIndexCount;

EdbCatalogue	edb_index_count_of_tuples	__P((EdbContext, ...));
void			edb_index_count_free		__P((EdbContext, EdbCatalogue));

#endif	/* Index_Inc_Defined */

