/*
$Id: link.h,v 1.13 2012/04/03 03:51:13 alex Exp alex $
	link.h--- link
	(C) Copyright 1994 by Alex
*/

#ifndef	Link_Inc_Defined
#define	Link_Inc_Defined

#include	<stdio.h>
#include	<stdlib.h>
#include	<sys/types.h>

struct LINK_OBJ {
	void		*d;
	void		(*f)();
	int		idx;
	void		*aux;
};
typedef	struct LINK_OBJ	*LinkObj;

struct LINK {
	struct LINK	*p;
	struct LINK	*n;
	void			*d;
	void			(*f)();
};
typedef	struct LINK	*Link;

Link		link_atom_new		__P((void *, void (*)()));
void		link_atom_free		__P((Link));
void		link_atom_free2		__P((void *, Link));
void		link_free			__P((Link));
void		link_free2			__P((void *, Link));
Link		link_head			__P((Link));
Link		link_tail			__P((Link));
Link		link_append		__P((Link, Link));
Link		link_insert			__P((Link, int, Link));
Link		link_atom_move_top	__P((Link, Link));
int		link_atoms		__P((Link));
Link		link_reverse		__P((Link));
Link		link_sort			__P((Link, int (*)(), void * (*)(), void *, void (*)()));
Link		link_randomize		__P((Link));
void		* link_get_obj		__P((Link, int));
Link		link_get_link		__P((Link, int));

Link		link_atom_new_sdup	__P((char *));
Link		link_atom_new_sndup	__P((char *, size_t));
Link		link_atom_new_i2s	__P((int));
Link		link_atom_new_spf	__P((char *, ...));

#define	ForLink(l, link)			for((l)=(link); (l) ; (l)=(l)->n)
#define	LinkAppend(link, l)		(link) = link_append((link), (l))
#define	LinkAppendTop(l, link)	(link) = link_append((l), (link))

#define	LinkReverse(link)		(link) = link_reverse((link))
/*
	stack
*/

void		*link_pop			__P((Link *));

#define	LinkPush(l, d)	((l)=link_append(link_atom_new((d), NULL), (l)))
#define	LinkPop(l)		link_pop(&(l))

#endif	/* Link_Inc_Defined */


