/*
	$Id: login.h,v 1.28 2011/04/18 09:46:32 alex Exp $
	login.h --- header file for login
*/

#ifndef	Login_Inc_Defined
#define	Login_Inc_Defined

#include	"edb/pki.h"

struct EDB_LOGIN {
	EdbContext	ec;
	EdbContext	session_ec;
	EdbContext	user_ec;
#define	EDB_SESSION_FOOTPRINT_TAG	"footprint"
	BiTree	footprint;
#define	EDB_SESSION_CANDIDATE_TAG	"candidate"
	Link		l_candidate;
#define	EDB_SESSION_CSV_TAG			"csv"
	Link		l_csv;
	int	login;

	eid_t	ssl_operator;
	EdbPkiCertificateInfo	ssl;

#define	EDB_SSL_LOGIN_AUTO_TAG	"ssl.login_auto"
#define	EDB_SSL_LOGIN_AUTO_DEFAULT	0
	int	ssl_login_auto;

#define	EDB_NOTIFY_IMMEDIATELY_TAG	"notify.immediately"
#define	EDB_NOTIFY_IMMEDIATELY_DEFAULT	0
	int	notify_immediately;

#define	EDB_USER_SKILL_TAG	"user.skill"
#define	EDB_USER_SKILL_NOVICE	0
#define	EDB_USER_SKILL_EXPERT	1
#define	EDB_USER_SKILL_MASTER	2
#define	EDB_USER_SKILL_HACKER	3
#define	EDB_USER_SKILL_DEFAULT	EDB_USER_SKILL_NOVICE
	int	user_skill;

#define	EDB_BROWSE_MAX_TUPLES_TAG	"browse.max_tuples"
#define	EDB_BROWSE_MAX_TUPLES_DEFAULT	512
	int	browse_max_tuples;

#define	EDB_BROWSE_PERSIST_CLASSIFY_TAG	"browse.persist_classify"
#define	EDB_BROWSE_PERSIST_CLASSIFY_DEFAULT	1
	int	browse_persist_classify;

#define	EDB_BROWSE_FRESH_DAYS_TAG	"browse.fresh_days"
#define	EDB_BROWSE_FRESH_DAYS_DEFAULT	3
	int	browse_fresh_days;

#define	EDB_EDIT_SELECT_MAX_TAG	"edit.select_max"
#define	EDB_EDIT_SELECT_MAX_DEFAULT		64
	int	edit_select_max;

#define	EDB_BROWSE_SHOW_STANDARD_TAG	"browse.show_standard"
#define	EDB_BROWSE_SHOW_STANDARD_DEFAULT	1
	int	browse_show_standard;

#define	EDB_BROWSE_SHOW_XML_TAG	"browse.show_xml"
#define	EDB_BROWSE_SHOW_XML_DEFAULT	0
	int	browse_show_xml;

#define	EDB_BROWSE_SHOW_EDITOR_TAG	"browse.show_editor"
#define	EDB_BROWSE_SHOW_EDITOR_DEFAULT	0
	int	browse_show_editor;

#define	EDB_EDIT_TEXTAREA_WIDTH_TAG	"edit.textarea_width"
#define	EDB_EDIT_TEXTAREA_WIDTH_DEFAULT	64
	int	edit_textarea_width;

#define	EDB_EDIT_SHOW_XML_TAG	"edit.show_xml"
#define	EDB_EDIT_SHOW_XML_DEFAULT	1
	int	edit_show_xml;

#define	EDB_EDIT_SHOW_STANDARD_TAG	"edit.show_standard"
#define	EDB_EDIT_SHOW_STANDARD__HIDE	0
#define	EDB_EDIT_SHOW_STANDARD__SAME_WINDOW	1
#define	EDB_EDIT_SHOW_STANDARD__DIFF_WINDOW		2
#define	EDB_EDIT_SHOW_STANDARD_DEFAULT	EDB_EDIT_SHOW_STANDARD__HIDE
	int	edit_show_standard;

#define	EDB_EDIT_SHOW_SELECTION_EID_TAG	"edit.show_selection_eid"
#define	EDB_EDIT_SHOW_SELECTION_EID_DEFAULT	0
	int	edit_show_selection_eid;

#define	EDB_EDIT_SHOW_SELECTION_READ_PERM_TAG	"edit.show_selection_read_perm"
#define	EDB_EDIT_SHOW_SELECTION_READ_PERM_DEFAULT	1
	int	edit_show_selection_read_perm;

#define	EDB_EDIT_ENABLE_ROUGH_MODE_TAG	"edit.enable_rough_mode"
#define	EDB_EDIT_ENABLE_ROUGH_MODE_DEFAULT	1
	int	edit_enable_rough_mode;

#define	EDB_EDIT_ENABLE_FAST_MODE_TAG	"edit.enable_fast_mode"
#define	EDB_EDIT_ENABLE_FAST_MODE_DEFAULT	0
	int	edit_enable_fast_mode;
	Doc	final_output_doc;

#define	EDB_DISPLAY_FONT_HEIGHT_TAG	"display.font_height"
#define	EDB_DISPLAY_FONT_HEIGHT_DEFAULT	14
	int	display_font_height;

#define	EDB_DISPLAY_DPI_TAG	"display.dpi"
#define	EDB_DISPLAY_DPI_DEFAULT	92
	int	display_dpi;

	int	us_expansion_selector;

	char	*session_id;
	int	session_data_is_changed;
	Link	session_data;
	Link	session_msg;
};
typedef	struct EDB_LOGIN	*EdbLogin;

extern	EdbLogin	edb_login_configure_SSL		__P((EdbContext));
extern	int		edb_login_session_open		__P((EdbLogin));
extern	int		edb_login_session_close		__P((EdbLogin));
extern	int		edb_login_session_login		__P((EdbLogin));
extern	void		edb_login_session_logout		__P((EdbLogin));

extern	void		edb_login_session_user_agent_capability	__P((EdbLogin));

extern	int		edb_login_reset_user_context	__P((EdbLogin, int));
extern	int		edb_login_put_user_context	__P((EdbLogin, int, char *, char *, ...));
extern	char *	edb_login_get_user_context	__P((EdbLogin, char *));

extern	int		edb_login_number_of_session_users	__P((EdbLogin));

extern	int		edb_login_session_auth		__P((EdbLogin, eid_t, char *));
extern	int		edb_login_session_auth_by_aituid	__P((EdbLogin, char *, char *));
extern	int		edb_login_session_auth_by_name	__P((EdbLogin, char *, char *));
extern	int		edb_login_session_auth_by_email	__P((EdbLogin, char *, char *));
extern	int		edb_login_session_auth_staff	__P((EdbLogin, eid_t, char *));
extern	int		edb_login_session_auth_Odin	__P((EdbLogin, eid_t, char *));

struct FOOTPRINT {
	char	*xmlname;
	eid_t	eid;
	time_t	ts;
};
typedef	struct FOOTPRINT	* FootPrint;

extern	int		edb_login_authentication		__P((EdbLogin, eid_t, Doc, int (*)(), void *));
extern	void		edb_login_footprint_add		__P((EdbLogin, char *, eid_t, time_t));
extern	void		edb_login_footprint_remove	__P((EdbLogin, eid_t));
extern	void		edb_login_footprint_clearall	__P((EdbLogin));
extern	int		edb_login_footprint_check		__P((EdbLogin, eid_t));
extern	void		edb_login_footprint_browse	__P((EdbLogin, char *, Doc));
extern	Link		edb_login_footprint_get_by_xmlname	__P((EdbLogin, char *));

#if 0
#define	EDB_USER_DB_TEMPLATE		"edb_user_template"
#endif

#endif	/* Login_Inc_Defined */



