/*
$Id: pki.h,v 1.15 2008/10/27 04:23:43 alex Exp $
	pki.h--- public key infrastructure
*/

#ifndef	PKI_Inc_Defined
#define	PKI_Inc_Defined

#if defined(EDB_MANAGE_PKI)

#define	EDB_PKI_OPENSSL_PATH	"/usr/bin/openssl"

#define	EDB_PKI_CERTIFICATE_MODE_USER	0
#define	EDB_PKI_CERTIFICATE_MODE_CLIENT	1
#define	EDB_PKI_CERTIFICATE_MODE_SERVER	2

// 1st Generation
#define	EDB_PKI_CA_DIR			EDB_PKI_DIR "/CA"
#define	EDB_PKI_CA_LOCKFILE		EDB_PKI_CA_DIR "/ca.lock"
#define	EDB_PKI_CA_CERT_INDEX	EDB_PKI_DIR "/CA/index.txt"

#define	EDB_PKI_RSA_BITs			2048
// # define	EDB_PKI_CERTIFICATE_DAYs	3650
// CA/Browsers Forum @ 2017-02-17
#define	EDB_PKI_CERTIFICATE_DAYs	825

#if 0
#define	EDB_PKI_CERTIFICATE_EXT_USER		"-extensions user_ext -extfile " EDB_PKI_CA_DIR "/etc/xpextensions"
#define	EDB_PKI_CERTIFICATE_EXT_CLIENT		"-extensions xpclient_ext -extfile " EDB_PKI_CA_DIR "/etc/xpextensions"
#define	EDB_PKI_CERTIFICATE_EXT_SERVER	"-extensions xpserver_ext -extfile " EDB_PKI_CA_DIR "/etc/xpextensions"
#endif

#define	EDB_PKI_CERTIFICATE_EXT_TAG_USER		"user_ext"
#define	EDB_PKI_CERTIFICATE_EXT_TAG_CLIENT	"xpclient_ext"
#define	EDB_PKI_CERTIFICATE_EXT_TAG_SERVER	"xpserver_ext"
#define	EDB_PKI_CERTIFICATE_EXT_FILE			EDB_PKI_CA_DIR "/etc/xpextensions"

// 2nd Generation
#define	EDB_PKI2_CA_DIR			EDB_PKI_DIR "/CA2nd"
#define	EDB_PKI2_CA_LOCKFILE		EDB_PKI2_CA_DIR "/ca.lock"
#define	EDB_PKI2_CA_CERT_INDEX	EDB_PKI_DIR "/CA2nd/index.txt"

#define	EDB_PKI2_RSA_BITs		4096
// define	EDB_PKI2_CERTIFICATE_DAYs	7300
// CA/Browsers Forum @ 2017-02-17
// # define	EDB_PKI2_CERTIFICATE_DAYs	825
// CA/Browsers Forum @ 2019-02-04
//# define	EDB_PKI2_CERTIFICATE_DAYs	3650
// CA/Browsers Forum @ 2020-09-01
# define	EDB_PKI2_CERTIFICATE_DAYs	396

#if 0
#define	EDB_PKI2_CERTIFICATE_EXT_USER		"-extensions user_ext -extfile " EDB_PKI2_CA_DIR "/etc/xpextensions"
#define	EDB_PKI2_CERTIFICATE_EXT_CLIENT	"-extensions xpclient_ext -extfile " EDB_PKI2_CA_DIR "/etc/xpextensions"
#define	EDB_PKI2_CERTIFICATE_EXT_SERVER	"-extensions xpserver_ext -extfile " EDB_PKI2_CA_DIR "/etc/xpextensions"
#endif

#define	EDB_PKI2_CERTIFICATE_EXT_TAG_USER		"user_ext"
#define	EDB_PKI2_CERTIFICATE_EXT_TAG_CLIENT	"xpclient_ext"
#define	EDB_PKI2_CERTIFICATE_EXT_TAG_SERVER	"xpserver_ext"
#define	EDB_PKI2_CERTIFICATE_EXT_FILE			EDB_PKI2_CA_DIR "/etc/xpextensions"

#endif	/* EDB_MANAGE_PKI */

// 1st Generation
#define	EDB_PKI_GENERATION		1
#define	EDB_PKI_CERT_STRING		"EDB/PKI 1st Generation Certificate"
#define	EDB_PKI_CA_CRT			EDB_PKI_DIR "/CA/cacert.pem"
#define	EDB_PKI_ROOT_CRT		EDB_PKI_DIR "/root.crt"
#define	EDB_PKI_ROOT_CRT_DIR		EDB_PKI_DIR "/crt"
#define	EDB_PKI_ROOT_CRL		EDB_PKI_DIR "/cert.crl"
#define	EDB_PKI_ROOT_CRL_DIR		EDB_PKI_DIR "/crl"

// 2nd Generation
#define	EDB_PKI2_GENERATION		2
#define	EDB_PKI2_CERT_STRING		"EDB/PKI 2nd Generation Certificate"
#define	EDB_PKI2_CA_CRT			EDB_PKI_DIR "/CA2nd/cacert2nd.pem"
#define	EDB_PKI2_ROOT_CRT		EDB_PKI_DIR "/root2nd.crt"
#define	EDB_PKI2_ROOT_CRT_DIR	EDB_PKI_DIR "/crt"
#define	EDB_PKI2_ROOT_CRL		EDB_PKI_DIR "/cert2nd.crl"
#define	EDB_PKI2_ROOT_CRL_DIR	EDB_PKI_DIR "/crl"

#define	EDB_PKI_ICON_CERTIFICATE	"/edb-icons/certificate.png"
#define	EDB_PKI_ICON_CERTIFICATE_REVOKED	"/edb-icons/certificate-revoked.png"

struct EDB_PKI_CERT_INDEX {
	utf8_t	*type;	/* 'R':revoke, 'E':Expire, 'V':Valid */
	utf8_t	*expire_date;
	utf8_t	*revoke_date;
	utf8_t	*serial;	/* serial number */
	utf8_t	*file;
	utf8_t	*DN;		/* distinguished name */
};
typedef struct EDB_PKI_CERT_INDEX	*EdbPkiCertIndex;

struct EDB_PKI_X509_M_INFO {
	int	version;
	int	serial;
};

struct EDB_PKI_X509_DN_INFO {
	utf8_t	*C;
	utf8_t	*ST;
	utf8_t	*L;
	utf8_t	*O;
	utf8_t	*OU;
	utf8_t	*CN;
	utf8_t	*Email;
};

struct EDB_PKI_X509_NAME_INFO {
	utf8_t	*DirName;
	struct EDB_PKI_X509_DN_INFO	DN;
};
typedef	struct EDB_PKI_X509_NAME_INFO	*EdbPkiNameInfo;

struct EDB_PKI_CERTIFICATE_INFO {
	struct	EDB_PKI_X509_M_INFO	M;
	struct	EDB_PKI_X509_NAME_INFO	I;
	struct	EDB_PKI_X509_NAME_INFO	S;
	Link		l_subjectAltNames;
	int		mode;
};
typedef	struct EDB_PKI_CERTIFICATE_INFO	*EdbPkiCertificateInfo;

#if defined(EDB_MANAGE_PKI)
int			edb_pki_IamCA						__P((EdbContext));
int			edb_pki_CA_lock					__P((EdbContext));
int			edb_pki_CA_unlock					__P((EdbContext));
int			edb_pki_CA_save_certificate_request	__P((EdbContext, int, utf8_t *, utf8_t *, int));
int			edb_pki_CA_make_certificate_request	__P((EdbContext, int, utf8_t *, utf8_t *));
utf8_t	*	edb_pki_CA_make_certificate			__P((EdbContext, int, utf8_t *, EdbPkiCertificateInfo, int));
void			edb_pki_CA_output_PKCS12			__P((EdbContext, int, utf8_t *, utf8_t *, FILE *));
void			edb_pki_CA_unlink_keyfile				__P((EdbContext, int, utf8_t *));
int			edb_pki_CA_revoke_certificate			__P((EdbContext, int, utf8_t *));
char		*	edb_pki_CA_certificate_serial			__P((EdbContext, int));
Link			edb_pki_CA_certificate_index			__P((EdbContext, int));
#else	/* EDB_MANAGE_PKI */
#define		edb_pki_IamCA(ec)					(FALSE)
#endif	/* EDB_MANAGE_PKI */

int			edb_pki_certificate_generation	__P((EdbContext, utf8_t *));
utf8_t	*	edb_pki_certificate_to_pem	__P((utf8_t *));
int			edb_pki_print_certificate_S_DN	__P((EdbContext, utf8_t *, Doc));
int			edb_pki_print_certificate_ex	__P((EdbContext, utf8_t *, Doc));
int			edb_pki_print_certificate		__P((EdbContext, utf8_t *, Doc));
int			edb_pki_print_certificate_info	__P((EdbContext, EdbPkiCertificateInfo, Doc));
int			edb_pki_check_certificate		__P((EdbContext, utf8_t *));
int			edb_pki_verify_certificate		__P((EdbContext, utf8_t *));

EdbColumnInfo	edb_pki_tuple_certifiable	__P((EdbContext, EdbTupleInfo));

#define	EdbPkiTupleCertificateRequestInfo_P	__P((EdbContext, EdbTupleInfo))
EdbPkiCertificateInfo
			edb_pki_tuple_certificate_request_info	EdbPkiTupleCertificateRequestInfo_P;

utf8_t	*	edb_pki_tuple_certificate		__P((EdbContext, EdbTupleInfo));

void	edb_pki_certificate_info_free	__P((EdbContext, EdbPkiCertificateInfo));
EdbPkiCertificateInfo	edb_pki_certificate_info	__P((EdbContext, utf8_t *));
EdbPkiCertificateInfo	edb_pki_SSL_env_info	__P((EdbContext));
int			edb_pki_certificate_info_equal	__P((EdbContext, EdbPkiCertificateInfo, EdbPkiCertificateInfo));

eid_t			edb_pki_person_CN2EID			__P((EdbContext, utf8_t *));
eid_t			edb_pki_personification_CN2EID		__P((EdbContext, utf8_t *));

utf8_t	*	edb_pki_person_EID2CN			__P((EdbContext, eid_t));
utf8_t	*	edb_pki_personification_EID2CN		__P((EdbContext, eid_t));

utf8_t	*	edb_pki_rsa_encrypt				__P((EdbContext, utf8_t *, int, char *));
int			edb_pki_rsa_decrypt				__P((EdbContext, utf8_t *, utf8_t **, int *, char *, char *));

#endif	/* PKI_Inc_Defined */


