/*
	$Id: site.h,v 1.38 2012/04/03 03:51:13 alex Exp alex $
	site.h--- site dependencies
*/

#ifndef	Site_Inc_Defined
#define	Site_Inc_Defined

/*
	EDBがインストールされるディレクトリ
*/
#ifndef	EDBDIR
#define	EDBDIR	"/usr/local/edb"
#endif

/*
	徳島大学依存のコードを作成するときに利用する．
	徳島大学以外では削除．
*/
#define	THE_UNIVERSITY_OF_TOKUSHIMA

/*
	データベースの名前，サーバ名など．
*/
#define	NAME_OF_DATABASE	"徳島大学 教育・研究者情報データベース"
#define	NAME_OF_DB			"EDB"

#define	WHOIS_SERVER	"db.db.tokushima-u.ac.jp"
#define	WEB_SERVER		"web.db.tokushima-u.ac.jp"
#define	WEB_PORTAL_URL	"http://" WEB_SERVER
#define	WEB_SERVER_URL	"https://" WEB_SERVER
#define	EDB_ADMIN_MAILADDR	"edb-admin@web.db.tokushima-u.ac.jp"

/* HTML頁に表示するメールアドレス．*/
#define	EDB_ADMIN_MAILADDR_SHOW		"edb-admin (at) web (dot) db (dot) tokushima-u (dot) ac (dot) jp"

#if 0
#define	DTD_SERVER		"web.ait230.tokushima-u.ac.jp"
#else
#define	DTD_SERVER		"web.db.tokushima-u.ac.jp"
#endif

#define	EDB_WG_NAME	"EDB Working Group"

#define	EDB_MASTER_UID	443
#define	EDB_DBPATH_DEFAULT	"localhost:5432:edb_database"

#define	WEB_DOCUMENT_ROOT	"/usr/local/www/data"

/*
	EDB のデバッガーのリスト (個人情報のEID)
	デバッグメッセージの表示に利用する．
*/
#define	EDB_DEBUGGER {				\
	10729,							\
	0}

/*
	WEB_ASSIST_DIR
	edb_assistが利用するデフォルトのコンテンツの場所．
	「ローカルディスクのパス名」または，URLを指定する．
	URLのスキームは "http"のみ許可される．
*/
#if 0
#define	WEB_ASSIST_DIR	WEB_DOCUMENT_ROOT "/assist"
#else
#if 0
#define	WEB_ASSIST_DIR	"http://web.e.tokushima-u.ac.jp/assist"
#else
#define	WEB_ASSIST_DIR	"http://cms.db.tokushima-u.ac.jp/EDB/share/assist"
#endif
#endif
/*
	edb_assistが中継しても良いドメイン
*/
#define	EDB_ASSIST_SOURCE_DOMAIN	"tokushima-u.ac.jp"

/*
	EID of TABLE information
*/
#define	EDB_TABLE_PERSON_EID		10014
#define	EDB_TABLE_PERSONIFICATION_EID	10015

/*
	EID: site depended
*/
#define	ORGAN_TOP_EID	10992	/* EID of My Organization */
#define	ORGAN_UNIV_EID	ORGAN_TOP_EID

/*
	DNS:	EDBを用いてDNS情報を管理する場合には下記を定義する．
*/
#define	EDB_MANAGE_DNS

#if defined(EDB_MANAGE_DNS)
#define	EDB_DNS_MINIMUM_SUBNETMASK		16
#endif /* EDB_MANAGE_DNS */

/*
	PKI:	EDBを用いてPKIを管理する場合には下記を定義する．
*/
#define	EDB_MANAGE_PKI

#if defined(EDB_MANAGE_PKI)

#define	EDB_PKI_DIR				EDBDIR "/libdata/pki"

#define	EDB_PKI_DN_C		"JP"
#define	EDB_PKI_DN_ST	"Tokushima"
#define	EDB_PKI_DN_L		"Tokushima City"
#define	EDB_PKI_DN_O	"The University of Tokushima"
#define	EDB_PKI_DN_OU	NAME_OF_DB

#endif /* EDB_MANAGE_PKI */

#define	EDB_PKI_STAFF_DN	"/C=JP/ST=Tokushima/L=Tokushima City/O=The University of Tokushima/OU=EDB/CN=S158456/emailAddress=edb-admin@db.tokushima-u.ac.jp"

#define	EDB_PKI_ROOT_CN		"root-ca.db.tokushima-u.ac.jp"
#define	EDB_PKI2_ROOT_CN	"root2nd-ca.db.tokushima-u.ac.jp"

/*
	EDB/CMS (Contents Management System)
*/
#define	EDB_PROVIDE_CMS

#if defined(EDB_PROVIDE_CMS)

#define	EDB_CMS_NAME	NAME_OF_DB "/CMS"

#define	EDB_CMS_SERVER	"cms.db.tokushima-u.ac.jp"
#define	EDB_CMS_PORTAL_URL	"http://" EDB_CMS_SERVER
#define	EDB_CMS_SERVER_URL	"https://" EDB_CMS_SERVER

#define	EDB_CMS_DAV_URL		EDB_CMS_PORTAL_URL "/DAV"
#define	EDB_CMS_DAVs_URL	EDB_CMS_SERVER_URL "/DAV"
#define	EDB_CMS_CONFIG_URL	EDB_CMS_SERVER_URL "/cgi-sbin/cms-config"
#define	EDB_CMS_SEARCH_URL	EDB_CMS_PORTAL_URL "/cgi-bin/cms-search"
#define	EDB_CMS_SEARCHs_URL	EDB_CMS_SERVER_URL "/cgi-sbin/cms-search"

#endif /* EDB_PROVIDE_CMS */

/*
	EdbClient
*/
#define	EDB_PROVIDE_EDBCLIENT

#if defined(EDB_PROVIDE_EDBCLIENT)

#define	EDB_CLIENT_NAME			"EdbClient"
#define	EDB_CLIENT_INVOKE_CGI	"/cgi-bin/edbclient"
#define	EDB_CLIENT_CODEBASE		"http://cms.db.tokushima-u.ac.jp/dist/EDB/Java/EdbCL"
#define	EDB_CLIENT_CLASS			"EdbCL"
#define	EDB_CLIENT_JAR			"EdbCL-signed.jar"

#endif /* EDB_PROVIDE_EDBCLIENT */

/*
	EdbAssistance
*/
#define	EDB_PROVIDE_EDBASSISTANCE

#if defined(EDB_PROVIDE_EDBASSISTANCE)

#define	EDB_ASSISTANCE_NAME			"EdbAssistance"
#define	EDB_ASSISTANCE_BROWSE_URL	"/Assistance/browse"

#endif /* EDB_PROVIDE_EDBASSISTANCE */

/*
	person's title
*/

#if 1
#define	TITLE_ATTRIBUTE_Personnel		245824
#define	TITLE_ATTRIBUTE_Teacher		245825
#define	TITLE_ATTRIBUTE_RegularTeacher	245832

#define	TITLE_COLUMN_ATTRIBUTE_XN	"title.attribute"

#else
#define	TITLE_TEACHER_LIST	{	\
		72731,	/* 学長 */			\
		82836,	/* 理事 */			\
		83223,	/* 病院長 */		\
		231390,	/* センター長 */	\
		244823,	/* センター長(併任) */	\
		10045,	/* 教授 */			\
		104093,	/* 教授(併任) */	\
		10047,	/* 助教授 */		\
		104094,	/* 助教授(併任) */	\
		151512,	/* 准教授 */			\
		151513,	/* 准教授(併任) */		\
		10048,	/* 講師 */			\
		104095,	/* 講師(併任) */	\
		10049,	/* 助手 */			\
		104096,	/* 助手(併任) */	\
		151514,	/* 助教 */				\
		151515,	/* 助教(併任) */		\
		151516,	/* 助手(H19) */			\
		151517,	/* 助手(H19)(併任) */	\
		164619,	/* 診療助教 */		\
		143817,	/* COE特任教授 */	\
		176537,	/*  特任教授 */	\
		144963,	/*  特任准教授 */	\
		176538,	/*  特任講師 */	\
		176539,	/*  特任助教 */	\
		0}

#define	TITLE_PERSONNEL_LIST	{	\
		72731,	/* 学長 */			\
		82836,	/* 理事 */			\
		83223,	/* 病院長 */		\
		231390,	/* センター長 */	\
		244823,	/* センター長(併任) */	\
		10045,	/* 教授 */			\
		104093,	/* 教授(併任) */	\
		10047,	/* 助教授 */		\
		104094,	/* 助教授(併任) */	\
		151512,	/* 准教授 */			\
		151513,	/* 准教授(併任) */		\
		10048,	/* 講師 */			\
		104095,	/* 講師(併任) */	\
		10049,	/* 助手 */			\
		104096,	/* 助手(併任) */	\
		151514,	/* 助教 */				\
		151515,	/* 助教(併任) */		\
		151516,	/* 助手(H19) */			\
		151517,	/* 助手(H19)(併任) */	\
		164619,	/* 診療助教 */		\
		10046,	/* 客員教授 */		\
		143817,	/* COE特任教授 */	\
		176537,	/*  特任教授 */	\
		144963,	/*  特任准教授 */	\
		176538,	/*  特任講師 */	\
		176539,	/*  特任助教 */	\
		10052,	/* 教務員 */		\
		10053,	/* 事務員 */		\
		10051,	/* 技術補佐員 */	\
		25974,	/* 教務補佐員 */	\
		25973,	/* 事務補佐員 */	\
		277118,	/* 技術専門職員 */		\
		10050,	/* 技術員 */		\
		236812,	/* 歯科技工師 */	\
		83096,	/* 課長 */			\
		83097,	/* 係長 */			\
		147876,	/* 学術研究員 */	\
		158435,	/* 学務部長 */		\
		158321,	/* 課長補佐 */		\
		158347,	/* 事務部長 */		\
		158599,	/* 専門員 */		\
		171724,	/* 技師 */			\
		226751,	/* 理学療法士 */	\
		229905,	/* 看護師長 */		\
		242745,	/* 副看護師長 */	\
		237362,	/* 栄養士 */		\
		0}
#endif

/*
	補助テーブル【言語】に登録されているものの中で，CJK言語圏に属するもの．
	すなわち，表示言語設定:自動において，日本語の選択が好ましいもの．
	和文，中文，ハングル等
*/
#define	LANGUAGE_JAPANESE_LIST	{	\
	60002,	/* 日本語 */				\
	60006,	/* 中国語 */				\
	144757,	/* 韓国語 */				\
	0}

/*
	省略してもいい市外局番
*/
#define	PHONE_EXCHANGE_NO	"088-"	/* 市外局番 */

/*
	学外文献データベースの情報
*/
#define	WOS_ENGAGED
#undef	WOS_ENGAGED
#define	Scopus_ENGAGED

#define EXTDB_DOI_Article_BASE_URL		"http://dx.doi.org/"
#define EXTDB_PubMed_Article_BASE_URL	"https://www.ncbi.nlm.nih.gov/pubmed/"
#define EXTDB_CiNii_Article_BASE_URL		"https://ci.nii.ac.jp/naid/"
#define EXTDB_WOS_Article_BASE_URL		"http://gateway.isiknowledge.com/gateway/Gateway.cgi?&GWVersion=2&SrcAuth=CustomerName&SrcApp=CustomerName&DestLinkType=FullRecord&KeyUT=%s&DestApp=WOS&DestApp=WOS"

#define EXTDB_WOSbyDOI_Article_BASE_URL		"http://apps.webofknowledge.com/WOS_GeneralSearch.do?fieldCount=1&action=search&product=WOS&search_mode=GeneralSearch&value(select1)=DO&value(input1)="
#define EXTDB_WOSbyPMID_Article_BASE_URL	"http://apps.webofknowledge.com/WOS_GeneralSearch.do?fieldCount=1&action=search&product=WOS&search_mode=GeneralSearch&value(select1)=PMID&value(input1)="
#define EXTDB_WOS_Researcher_BASE_URL		"http://apps.webofknowledge.com/WOS_GeneralSearch.do?fieldCount=1&action=search&product=WOS&search_mode=GeneralSearch&value(select1)=AI&value(input1)=%s"

#define EXTDB_WOS_JCR_explanation_link		"http://www.thomsonreuters.com/journal-citation-reports/"

#define EXTDB_WOS_JCR_explanation			"2003-2014 Journal Citation Reports\u00ae Science Edition (Thomson Reuters, 2004-2015)"

#define EXTDB_Scopus_Article_BASE_URL		"http://www.scopus.com/record/display.url?eid=%s&origin=inward"
#define EXTDB_ScopusByDOI_Article_BASE_URL	"http://www.scopus.com/results/results.url?sort=plf-f&src=s&sot=a&sdt=a&origin=searchadvanced"
#define EXTDB_Scopus_Author_BASE_URL		"http://www.scopus.com/authid/detail.url?authorId=%s"

#define EXTDB_WOS_BGC				"#ffc080"
#define EXTDB_Scopus_BGC				"#80ffc0"

// define EXTDB_Scopus_SJR_explanation_link		"http://www.journalmetrics.com/sjr.php"
// define EXTDB_Scopus_IPP_explanation_link		"http://www.journalmetrics.com/ipp.php"
// define EXTDB_Scopus_SNIP_explanation_link		"http://www.journalmetrics.com/snip.php"

// define EXTDB_Scopus_SJR_explanation_link			"https://help.elsevier.com/app/answers/detail/a_id/2899/p/8150/kw/Journal%20Metrics/search/1"
// define EXTDB_Scopus_CiteScore_explanation_link		"https://help.elsevier.com/app/answers/detail/a_id/5221/p/8150/kw/Journal%20Metrics/search/1"
// define EXTDB_Scopus_SNIP_explanation_link			"https://help.elsevier.com/app/answers/detail/a_id/2900/p/8150/kw/Journal%20Metrics/search/1"

#define EXTDB_Scopus_SJR_explanation_link			"https://www.elsevier.com/authors/journal-authors/measuring-a-journals-impact"
#define EXTDB_Scopus_CiteScore_explanation_link		"https://www.elsevier.com/authors/journal-authors/measuring-a-journals-impact"
#define EXTDB_Scopus_SNIP_explanation_link			"https://www.elsevier.com/authors/journal-authors/measuring-a-journals-impact"

#define EXTDB_Scopus_SJR_explanation		"<b>SCImago Journal Rank (SJR)</b> is a measure of scientific influence of scholarly journals that accounts for both the number of citations received by a journal and the importance or prestige of the journals where such citations come from."
// #def ine EXTDB_Scopus_IPP_explanation	"<b>Impact per Paper (IPP)</b> measures the ratio of citations in a year (Y) to scholarly papers published in the three previous years (Y-1, Y-2, Y-3) divided by the number of scholarly papers publish in those same years (Y-1, Y-2, Y-3)."
#define EXTDB_Scopus_CiteScore_explanation	"<b>CiteScore</b> calcutates the average citations received per document. CiteScore is the number of citations received by a journal in one year to documents published in the three previous years, divided by the number of documents indexed in Scopus published in those same three years."
#define EXTDB_Scopus_SNIP_explanation		"<b>Source Normalized Impact per Paper (SNIP)</b> measures contextual citation impact by weighting citations based on the total number of citations in a subject field."
#define EXTDB_Scopus_poweredByScopus	"<a href=\"http://www.scopus.com\" target=\"_blank\" style=\"border-bottom-style:none;\"><img src=\"/img/poweredByScopus.png\" alt=\"[Powered by Scopus]\" height=\"14\" /></a>"

#define EXTDB_TUIR_Article_BASE_URL		"http://www.lib.tokushima-u.ac.jp/repository/metadata/%s"

#define EXTDB_ORCID_BASE_URL		"https://orcid.org/%s"

#define	Enable_AITUID
#if defined(Enable_AITUID)
#define	AIT_EDB_SHA	EDBDIR "/etc/ait-edb-sha"
#endif

// 附属図書館機関リポジトリ連携
#define	TUIR_COOPERATION



#endif /* Site_Inc_Defined */

