/*
	$Id: unicode.h,v 1.11 2008/08/09 09:21:37 alex Exp $
	unicode.h --- header for unicode
*/

#ifndef	UNICODE_Inc_Defined
#define	UNICODE_Inc_Defined

#include	<unistd.h>
#include	<stdlib.h>
#include	"edb/link.h"

#ifndef	TRUE
#define	TRUE	(1)
#endif

#ifndef	FALSE
#define	FALSE	(0)
#endif

#ifndef	ERROR
#define	ERROR	(-1)
#endif

typedef	int32_t		ucs4_t;	/* 32bit integer */
typedef	u_int8_t		utf8_t;	/* 8bit char */

#define	STR_CODE_ASCII	0
#define	STR_CODE_JIS		1
#define	STR_CODE_EUC	2
#define	STR_CODE_SJIS	3
#define	STR_CODE_UTF8	4

extern int	convJIStoUCS4		__P((unsigned char *, ucs4_t *));
extern int	convUCS4toJIS		__P((ucs4_t *, unsigned char *));
extern int	convEUCtoUCS4	__P((unsigned char *, ucs4_t *));
extern int	convSJIStoUCS4	__P((unsigned char *, ucs4_t *));

#define	UCS4_NULL	0x00000000
#define	UCS4_INVALID	0x80000000

#define	UCS4_TAB	0x00000009
#define	UCS4_NL		0x0000000a
#define	UCS4_CR		0x0000000d
#define	UCS4_SPACE	0x00000020
#define	UCS4_WSPACE	0x00003000

#define	UCS4_checkmark		0x00002713	/* check mark */

#define	UCS4_W0		0x0000ff10	/* ０ */
#define	UCS4_W1		0x0000ff11	/* １ */
#define	UCS4_W2		0x0000ff12	/* ２ */
#define	UCS4_W3		0x0000ff13	/* ３ */
#define	UCS4_W4		0x0000ff14	/* ４ */
#define	UCS4_W5		0x0000ff15	/* ５ */
#define	UCS4_W6		0x0000ff16	/* ６ */
#define	UCS4_W7		0x0000ff17	/* ７ */
#define	UCS4_W8		0x0000ff18	/* ８ */
#define	UCS4_W9		0x0000ff19	/* ９ */

#define	UCS4_WKvm	0x00003099	/* 濁音 voice mark */
#define	UCS4_WKsvm	0x0000309a	/* 半濁音 semi voice mark */

#define	UCS4_WKxa	0x000030a1	/* ァ */
#define	UCS4_WKxi	0x000030a3	/* ィ */
#define	UCS4_WKxu	0x000030a5	/* ゥ */
#define	UCS4_WKxe	0x000030a7	/* ェ */
#define	UCS4_WKxo	0x000030a9	/* ォ */
#define	UCS4_WKBA	0x000030d0	/* バ */
#define	UCS4_WKBI	0x000030d3	/* ビ */
#define	UCS4_WKBU	0x000030d6	/* ブ */
#define	UCS4_WKBE	0x000030d9	/* ベ */
#define	UCS4_WKBO	0x000030dc	/* ボ */
#define	UCS4_WKVU	0x000030f4	/* ヴ */
#define	UCS4_WA		0x0000ff21	/* Ａ */
#define	UCS4_WZ		0x0000ff3a	/* Ｚ */
#define	UCS4_Wa		0x0000ff41	/* ａ */
#define	UCS4_Wz		0x0000ff5a	/* ｚ */
#define	UCS4_WLONG_VOWEL	0x000030fc	/* ー */

#define	UCS4_UTF16_BOM		0x0000feff	/* byte order mark */
#define	UCS4_UTF16_BOM_BE	0x0000feff	/* byte order mark (big endian) */
#define	UCS4_UTF16_BOM_LE	0x0000fffe	/* byte order mark (little endian) */

#define	UTF8_EI0		0xef				/* byte order mark (encoding identifier) */
#define	UTF8_EI1		0xbb				/* byte order mark (encoding identifier) */
#define	UTF8_EI2		0xbf				/* byte order mark (encoding identifier) */

#define	UCS4_PrivateUseArea_BEGIN		0x0000e000
#define	UCS4_PrivateUseArea_END		0x0000f8ff
#define	UCS4_PrivateUseAreaA_BEGIN		0x000f0000
#define	UCS4_PrivateUseAreaA_END		0x000ffffd
#define	UCS4_PrivateUseAreaB_BEGIN		0x00100000
#define	UCS4_PrivateUseAreaB_END		0x0010fffd

#if 0
#define	UCS4_HIRAGANA_TOP	0xa400
#define	UCS4_KATAKANA_TOP	0xa500
#endif

/*
	CONVERSION FUNCTIONs
*/
int		convUTF8toUCS4	__P((utf8_t *, ucs4_t *));
int		convUCS4toUTF8	__P((ucs4_t *, utf8_t *));

ucs4_t	* utf8_to_ucs4	__P((utf8_t *, ucs4_t *));
utf8_t	* ucs4_to_utf8	__P((ucs4_t *, utf8_t *));

int		ucs4_strlen	__P((ucs4_t *));

#define	UTF8toUCS4(u)		\
			(utf8_to_ucs4((u),	\
				(ucs4_t *)alloca(sizeof(ucs4_t)*(convUTF8toUCS4((u), NULL)+1))))

#define	UCS4toUTF8(u)		\
			(ucs4_to_utf8((u),	\
				(utf8_t *)alloca(sizeof(utf8_t)*(convUCS4toUTF8((u), NULL)+1))))

#define	UCS4_STRDUP(u)	\
			(ucs4_strcpy((ucs4_t *)alloca(sizeof(ucs4_t)*(ucs4_strlen(u)+1)), (u)))

#define	UCS4_STRALLOC(n)	((ucs4_t *)alloca(sizeof(ucs4_t)*(n)))

#define	ucs4_isupper(c)	( ('A'<=(c) && (c)<='Z') )
#define	ucs4_islower(c)	( ('a'<=(c) && (c)<='z') )
#define	ucs4_toupper(c)	( (c)&~0x20 )
#define	ucs4_tolower(c)	( (c)|0x20 )

#define	ucs4_iswupper(c)	( (UCS4_WA<=(c) && (c)<=UCS4_WZ) )
#define	ucs4_iswlower(c)	( (UCS4_Wa<=(c) && (c)<=UCS4_Wz) )
#define	ucs4_towupper(c)	( ucs4_iswlower(c) ? (c)-0x20 : (c))
#define	ucs4_towlower(c)	( ucs4_iswupper(c) ? (c)+0x20 : (c))

#define	ucs4_isascii(c)		( !((c)&~0177) )

#define	ucs4_isalpha(c)		( ucs4_isupper((c)) || ucs4_islower((c)) )
#define	ucs4_iswalpha(c)	( ucs4_iswupper((c)) || ucs4_iswlower((c)) )

#define	ucs4_isdigit(c)		( ('0'<=(c) && (c)<='9') )
#define	ucs4_iswdigit(c)	( (UCS4_W0<=(c) && (c)<=UCS4_W9) )

#define	ucs4_isalnum(c)	( ucs4_isalpha((c)) || ucs4_isdigit((c)) )
#define	ucs4_iswalnum(c)	( ucs4_iswalpha((c)) || ucs4_iswdigit((c)) )

#define	ucs4_iswhitespace(c)	( (c)==UCS4_SPACE || (c)==UCS4_WSPACE || (c)==UCS4_TAB )

#define	ucs4_ishiragana(c)	( (0x00003041<=(c) && (c) <= 0x00003096) || (c)==UCS4_WLONG_VOWEL )
#define	ucs4_iskatakana(c)	( (0x000030a1<=(c) && (c) <= 0x000030f6) || (c)==UCS4_WLONG_VOWEL )

#define	ucs4_tokatakana(c)	( (0x00003041<=(c) && (c) <= 0x00003096) ? ((c)+0x60) : (c) )
#define	ucs4_tohiragana(c)	( (0x000030a1<=(c) && (c) <= 0x000030f6) ? ((c)-0x60) : (c) )

/* English/Japanese/Pronounce */

#define	ucs4_isEnglish(c)	(						\
		/* Basic Latin */								\
		(0x0020<=(c) && (c)<=0x007e)					\
		/* Latin-1Supplement / Latin Extended-A / Latin Extended-B */		\
	||	(0x00a1<=(c) && (c)<=0x0233 && (c)!=0x00ad && (c)!=0x0221)	\
		/* Greek and Coptic */						\
	||	(0x0391<=(c) && (c)<=0x03f6 && (c)!=0x03a2 && (c)!=0x03cf)		\
		/* Letterlike Symbols */						\
	||	(0x2100<=(c) && (c)<=0x214b && (c)!=0x213b && (c)!=0x213c)	\
		/* Letterlike Symbols */						\
	||	((0x2190<=(c) && (c)<=0x2193) || (c)==0x21d2 || (c)==0x21d4)		\
		/* Mathematical Operators */					\
	||	(0x2200<=(c) && (c)<=0x22ff)					\
	)


#define	ucs4_isJapanese(c)	(												\
		/* not control char */													\
		(0x0020<=(c))														\
		/* halfwidth CJK punctuation / katakana / hangle / symbol */					\
	&&	!((0xff61<=(c) && (c)<=0xffdf) || (0xffe7<=(c) && (c)<=0xffef))				\
		/* Private use area A / B */												\
	&&	!(UCS4_PrivateUseArea_BEGIN<=(c) && (c)<=UCS4_PrivateUseArea_END)		\
	&&	!(UCS4_PrivateUseAreaA_BEGIN<=(c) && (c)<=UCS4_PrivateUseAreaA_END)		\
	&&	!(UCS4_PrivateUseAreaB_BEGIN<=(c) && (c)<=UCS4_PrivateUseAreaB_END)		\
	)

#define	ucs4_isPronounce(c)		(	\
		ucs4_ishiragana((c))			\
	||	ucs4_iskatakana((c))		\
	||	(c)==UCS4_SPACE			\
	)

#if  0
#define	ucs4_iszenkaku(c)	(((c)&0x8080)==0x8080)
#define	ucs4_iskanji		( (c)>=0xb000 )
#endif

/*
	FUNCTIONs
*/
int		utf8string_is_valid	__P((utf8_t *));
ucs4_t *	ucs4_strcat		__P((ucs4_t *,	ucs4_t *));
ucs4_t *	ucs4_strncat		__P((ucs4_t *,	ucs4_t *,	int));
int		ucs4_strcmp		__P((ucs4_t *,	ucs4_t *));
int		ucs4_strncmp		__P((ucs4_t *,	ucs4_t *,	int));
int		ucs4_strcasecmp	__P((ucs4_t *,	ucs4_t *));
int		ucs4_strncasecmp	__P((ucs4_t *,	ucs4_t *,	int));
ucs4_t *	ucs4_strcpy		__P((ucs4_t *,	ucs4_t *));
ucs4_t *	ucs4_strncpy		__P((ucs4_t *,	ucs4_t *,	int));
int		ucs4_strlen		__P((ucs4_t *));
ucs4_t *	ucs4_index		__P((ucs4_t *,	ucs4_t));
ucs4_t *	ucs4_caseindex		__P((ucs4_t *,	ucs4_t));
ucs4_t *	ucs4_rindex		__P((ucs4_t *,	ucs4_t));
ucs4_t *	ucs4_strstr		__P((ucs4_t *,	ucs4_t *));
ucs4_t *	ucs4_strcasestr	__P((ucs4_t *,	ucs4_t *));
ucs4_t *	ucs4_strdup		__P((ucs4_t *));
ucs4_t *	ucs4_strndup		__P((ucs4_t *,	int));
ucs4_t *	ucs4_strmerge		__P((ucs4_t *,	ucs4_t *));
ucs4_t *	ucs4_strrev		__P((ucs4_t *));

void		ucs4_str_tokatakana		__P((ucs4_t *));
Link		ucs4_str_split			__P((ucs4_t *,	ucs4_t));
ucs4_t *	ucs4_str_concatenate	__P((Link,	 ucs4_t));
Link		ucs4_str_split_bychar	__P((ucs4_t *));
void		ucs4_str_capitalize1		__P((ucs4_t *));
void		ucs4_str_capitalize		__P((ucs4_t *, ucs4_t *));
void		ucs4_str_minuscule1		__P((ucs4_t *));
void		ucs4_str_minuscule		__P((ucs4_t *, ucs4_t *));

int		ucs4_str_isascii		__P((ucs4_t *));
int		ucs4_str_isalpha		__P((ucs4_t *));
int		ucs4_str_isalnum		__P((ucs4_t *));
int		ucs4_str_iswalnum		__P((ucs4_t *));
int		ucs4_str_isupper		__P((ucs4_t *));
int		ucs4_str_islower		__P((ucs4_t *));
int		ucs4_str_isdigit			__P((ucs4_t *));
int		ucs4_str_iskana		__P((ucs4_t *));
int		ucs4_str_ishiragana		__P((ucs4_t *));
int		ucs4_str_iskatakana		__P((ucs4_t *));

void		ucs4_str_oneline		__P((ucs4_t *));
void		ucs4_str_standard		__P((ucs4_t *));
void		ucs4_str_onephrase		__P((ucs4_t *));
Link		ucs4_str_split_bytoken	__P((ucs4_t *));

Link		file_load_as_linked_ucs4_str	__P((char *, FILE *));

#define	UCS4_STRisValid(s)			((s)!=NULL && (s)[0]!=UCS4_NULL)
#define	UCS4_STRisVALID(s)		UCS4_STRisValid((s))

struct UNICODE_VARIANT {
	ucs4_t	src;
	ucs4_t	dst;
};
typedef	struct UNICODE_VARIANT	*UnicodeVariant;

size_t	utf8_strlen			__P((utf8_t *));
utf8_t *	utf8_strdup			__P((utf8_t *));
utf8_t *	utf8_strcpy			__P((utf8_t *, utf8_t *));
utf8_t *	utf8_strncpy			__P((utf8_t *, utf8_t *, size_t));
int		utf8_strcmp			__P((utf8_t *, utf8_t *));
int		utf8_strncmp			__P((utf8_t *, utf8_t *, size_t));
int		utf8_strcasecmp		__P((utf8_t *, utf8_t *));
int		utf8_strncasecmp		__P((utf8_t *, utf8_t *, size_t));

#endif	/* UNICODE_Inc_Defined */

