/*
	$Id: utlf.h,v 1.2 2008/10/27 04:23:52 alex Exp $
	utlf.h --- header file for utlf
*/

#ifndef	UTLF_Inc_Defined
#define	UTLF_Inc_Defined

struct _UTLF {
	char	*id;
	char	*title;
	char	*creator;
	char	*date;
	char	*description;
	char	*publisher;
	char	*format;
	char	*replaces;
	int	indent;
	int	keyed;
};
typedef	struct _UTLF	*UTLF;

UTLF		utlf_new	__P((char *));
void		utlf_free	__P((UTLF));

void		utlf_set_title			__P((UTLF, char *));
void		utlf_set_creator		__P((UTLF, char *));
void		utlf_set_creator_by_EID	__P((UTLF, eid_t));
void		utlf_set_description		__P((UTLF, char *));
void		utlf_set_publisher		__P((UTLF, char *));
void		utlf_set_format			__P((UTLF, char *));
void		utlf_set_replaces		__P((UTLF, char *));
void		utlf_set_date_now		__P((UTLF));

void		utlf_print_header		__P((UTLF, FILE *));
void		utlf_print_trailer		__P((UTLF, FILE *));

void		utlf_content_begin		__P((UTLF, FILE *));
void		utlf_content_end		__P((UTLF, FILE *));

void		utlf_element_begin		__P((UTLF, char *, FILE *));
void		utlf_element_end		__P((UTLF, char *, FILE *));

void		utlf_element			__P((UTLF, char *, FILE *, char *, ...));

#define	UTLF_NS				"utlf"
#define	UTLF_CONTAINER_ID	UTLF_NS ":" "Container"

#define	UTLF_DICT			UTLF_NS ":" "dict"
#define	UTLF_ARRAY			UTLF_NS ":" "array"

#define	UTLF_KEY				UTLF_NS ":" "key"
#define	UTLF_STRING			UTLF_NS ":" "string"
#define	UTLF_REFERENCE		UTLF_NS ":" "reference"
#define	UTLF_TRUE			UTLF_NS ":" "true"
#define	UTLF_FALSE			UTLF_NS ":" "false"
#define	UTLF_NULL			UTLF_NS ":" "null"

char	*	utlf_make_tuple_rdfxml	__P((EdbContext, EdbTupleInfo));

#define	UTLF_EDB_ID		"EDB.db.tokushima-u.ac.jp"
#define	UTLF_EID_FMT		UTLF_NS ":EID=%d/" UTLF_EDB_ID

#endif	/* UTLF_Inc_Defined */


