/*
	$Id: xml.h,v 1.9 2011/04/18 09:45:28 alex Exp $
	xml.h --- header file for xml
*/

#ifndef	XML_Inc_Defined
#define	XML_Inc_Defined

#include	<libxml/xmlmemory.h>
#include	<libxml/parser.h>

#define	EDB_XMLNS	"edb"
#define	EDB_XMLNS_URI	"http://" DTD_SERVER "/dtds/"
#define	EDB_DTD_URI		"http://" DTD_SERVER "/dtds/"

utf8_t	*	xml_get_node_text				__P((EdbContext, xmlDocPtr, xmlNodePtr));

xmlNodePtr	xml_find_element_node			__P((EdbContext, xmlDocPtr, xmlNodePtr, ...));
Link			xml_find_element_node_list		__P((EdbContext, xmlDocPtr, xmlNodePtr, ...));
xmlChar *		xml_get_element_text			__P((EdbContext, xmlDocPtr, xmlNodePtr, ...));
int			xml_get_element_mtext			__P((EdbContext, utf8_t **, utf8_t **, utf8_t **, xmlDocPtr, xmlNodePtr, ...));
int			xml_get_element_text_integer		__P((EdbContext, xmlDocPtr, xmlNodePtr, int, ...));
int			xml_get_element_text_permission	__P((EdbContext, xmlDocPtr, xmlNodePtr, int, ...));
int			xml_get_element_permission		__P((EdbContext, void *, xmlDocPtr, xmlNodePtr, ...));
xmlChar *		xml_get_element_attr			__P((EdbContext, xmlDocPtr, xmlNodePtr, xmlChar *, ...));
int			xml_get_element_attr_integer		__P((EdbContext, xmlDocPtr, xmlNodePtr, xmlChar *, int, ...));
int			xml_get_element_attr_bool		__P((EdbContext, xmlDocPtr, xmlNodePtr, xmlChar *, int, ...));
int			xml_get_element_attr_permission	__P((EdbContext, xmlDocPtr, xmlNodePtr, xmlChar *, int, ...));

utf8_t	*	xml_make_element_text			__P((EdbContext, utf8_t *, utf8_t *));
utf8_t	*	xml_make_element_text_with_attr	__P((EdbContext, utf8_t *, utf8_t *, utf8_t *));
utf8_t	*	xml_make_element_text_integer	__P((EdbContext, utf8_t *, int));
utf8_t	*	xml_make_element_mtext			__P((EdbContext, utf8_t *, utf8_t *, utf8_t *));
utf8_t	*	xml_make_element_permission		__P((EdbContext, void *, int));

utf8_t	*	xml_text_encode				__P((EdbContext, utf8_t *));

/* mapping */
#define	XML_AN_MAPTO		"mapto"

/* chronological */
#define	XML_AN_DATE_FROM	"date.from"
#define	XML_AN_DATE_TO		"date.to"
#define	XML_AN_DATE_FROM_DEFAULT	0
#define	XML_AN_DATE_TO_DEFAULT		99999999

/* permission */
#define	XML_AN_READ			"read"
#define	XML_AN_WRITE		"write"
#define	XML_AN_DELETE		"delete"

/* assert */
#define	XML_AN_ASSERT		"assert"

#define	XML_AV_ASSERT_NOTHING		"nothing"

/* global elements */
#define	XML_EN_BASE			"base"
#define	XML_EN_ENGLISH		"english"
#define	XML_EN_JAPANESE		"japanese"
#define	XML_EN_PRONOUNCE	"pronounce"

#endif	/* XML_Inc_Defined */

