/*
	$Id: xmldb.h,v 1.4 2011/04/18 09:45:28 alex Exp $
	xmldb.h --- header file for XMLDB
*/

#ifndef	XMLDB_Inc_Defined
#define	XMLDB_Inc_Defined

eid_t		edb_xmldb_eid_max	__P((EdbContext));
eoid_t	edb_xmldb_eoid_max	__P((EdbContext));
eoid_t	edb_xmldb_eoid_of_tuple_max	__P((EdbContext));

#define	EDB_XMLDB_TABLE			"edb_xmldb"
#define	EDB_XMLDB_COLUMN_EID	"eid"
#define	EDB_XMLDB_COLUMN_EOID	"eoid"
#define	EDB_XMLDB_COLUMN_TEID	"teid"
#define	EDB_XMLDB_COLUMN_XML	"xml"

#if defined(__LIBEDB__)
struct EDB_XMLDB_INFO {
	eid_t		eid;
	eoid_t	eoid;
	eid_t		teid;
	utf8_t	*xml;
};

#define	XmldbEID(xi)	((xi)->eid)
#define	XmldbEOID(xi)	((xi)->eoid)
#define	XmldbTEID(xi)	((xi)->teid)
#define	XmldbXML(xi)	((xi)->xml)

typedef struct EDB_XMLDB_INFO *EdbXmldbInfo;

EdbXmldbInfo	edb_xmldb_new		__P((EdbContext));
void			edb_xmldb_free		__P((EdbContext, EdbXmldbInfo));
EdbXmldbInfo	edb_xmldb_dup		__P((EdbContext, EdbXmldbInfo));

int			edb_xmldb_compare	__P((EdbContext, EdbXmldbInfo, EdbXmldbInfo));

EdbXmldbInfo	edb_xmldb_get		__P((EdbContext, eid_t, eoid_t));

#if defined(EDB_READER)
#else	/* EDB_READER */
eoid_t		edb_xmldb_put		__P((EdbContext, EdbXmldbInfo));
int			edb_xmldb_delete	__P((EdbContext, eid_t, eoid_t));
#endif	/* EDB_READER */

Link			edb_xmldb_get_byTEID	__P((EdbContext, eid_t, int));
Link			edb_xmldb_get_byEID	__P((EdbContext, eid_t));
#endif	/* __LIBEDB__ */

#endif	/* XMLDB_Inc_Defined */

