/*
$Header: /usr/staff/alex/edb/srcs/libedbpub/igr/RCS/igr.h,v 1.1 2004/03/30 13:05:53 alex Exp alex $
	igr.h--- header file of igr
	(C) Copyright 1999 by Alex
*/

#ifndef	Igr_Inc_Defined
#define	Igr_Inc_Defined

#include	<stdlib.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<sys/file.h>

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef NULL
#define NULL 0
#endif

#ifndef	min
#define	min(x, y)	((x)<(y)?(x):(y))
#endif

#ifndef	max
#define	max(x, y)	((x)>(y)?(x):(y))
#endif

#ifndef	sqr
#define	sqr(x)		((x)*(x))
#endif

#ifndef	PI
#define PI   3.14159265358979323846
#endif

#define	IGR_FBITs	16

typedef	struct {
	int x, y;
} IgrVec;

typedef struct {
	int x, y, xsize, ysize;
} IgrRect;

typedef struct {
	int x, y, r;
} IgrCirc;

typedef struct _IGR_GC {
	caddr_t	d;

	/* xsize, ysize */
	int		xsize;
	int		ysize;

	/* graphic context */
	unsigned long	foreground;
	unsigned long	background;

	void	(*dot_func)();

#if 0
	/* font */
	XFontStruct		*font;		/* 8 bits font */
	XFontStruct		*font16;	/* 16 bits font */
#endif

	/* coordinate control */
#define N_BASES		1000		/* maximum number of base */
	IgrVec			base;
	IgrVec			base_stack[N_BASES];
	int				base_sp;

	/* clip control */
#define N_CLIPS		1000		/* maximum number of clip */
	IgrRect			clip_stack[N_CLIPS];
	int				clip_sp;
} *IgrGC;


/*************/
/* constants */
/*************/
/* directions */
#define	IGR_DIR_NORTH	90
#define	IGR_DIR_EAST	0
#define	IGR_DIR_SOUTH	270
#define	IGR_DIR_WEST	180

#define	IGR_DIR_RIGHT	0
#define	IGR_DIR_UP		90
#define	IGR_DIR_LEFT	180
#define	IGR_DIR_DOWN	270

/*************/
/* functions */
/*************/
IgrGC			IgrInit();
IgrGC			IgrOpen();

#define	IgrFGC(c)		((c)->foreground)
#define	IgrBGC(c)		((c)->background)

/*****************************/
/* igr (single display mode) */
/*****************************/
extern IgrGC _xgc;		/* graphic context for xgc_*() */

/* control */
#define	igr_init(w,h)				(_xgc = IgrInit(NULL,(w),(h)))
#define	igr_exit()					IgrExit(_xgc)
#define	igr_realize_mode(m)			IgrRealizeMode((_xgc), (m))
#define	igr_flush()					IgrFlush(_xgc)
#define	igr_refresh()				IgrRefresh(_xgc)

/* get xsize/ysize/class/depth of window */
#define	igr_xsize()					IgrXsize((_xgc))
#define	igr_ysize()					IgrYsize((_xgc))
#define	igr_visual_class()			IgrVisualClass((_xgc))
#define	igr_depth()					IgrDepth((_xgc))

/* move/raise/lower */
#define	igr_move(x, y)				IgrMove((_xgc), (x), (y))
#define	igr_resize(w, h)			IgrResize((_xgc), (w), (h))
#define	igr_raise()					IgrRaise(_xgc)
#define	igr_lower()					IgrLower(_xgc)

/* name of window */
#define	igr_name(n)					IgrName((_xgc), (n))

/* coordinate */
#define	igr_base_push(x,y)			IgrBasePush((_xgc), (x), (y))
#define	igr_base_pop()				IgrBasePop((_xgc))

/* clip */
#define	igr_clip_push(x, y, xs, ys)	IgrClipPush((_xgc), (x), (y), (xs), (ys))
#define	igr_clip_pop()				IgrClipPop((_xgc))

/* clear */
#define igr_clear()					IgrClear((_xgc))

/* colors */
#define	igr_fgc()					IgrFGC(_xgc)
#define	igr_bgc()					IgrBGC(_xgc)
#define	igr_alloc_color(r,g,b)		IgrAllocColor((_xgc), (r), (g), (b))
#define	igr_alloc_named_color(n)	IgrAllocNamedColor((_xgc), (n))
#define	igr_free_color(c)			IgrFreeColor((_xgc), (c))

/* bell */
#define	igr_bell()					IgrBell(_xgc)

/* dot */
#define	igr_dot(x,y,c)				IgrDot((_xgc),(x),(y),(c))
#define	igr_comp_dot(x,y)			IgrCompDot((_xgc),(x),(y))
#define	igr_dots(d,n,c)				IgrDots((_xgc),(d),(n),(c))
#define	igr_comp_dots(d,n)			IgrCompDots((_xgc),(d),(n))

/* line */
#define igr_line(x1,y1,x2,y2,c)		IgrLine((_xgc),(x1),(y1),(x2),(y2),(c))
#define igr_comp_line(x1,y1,x2,y2)	IgrCompLine((_xgc),(x1),(y1),(x2),(y2))

/* rectangle */
#define	igr_rectangle(x,y,w,h,c)	IgrRectangle((_xgc),(x),(y),(w),(h),(c))
#define	igr_comp_rectangle(x,y,w,h)	IgrCompRectangle((_xgc),(x),(y),(w),(h))
#define	igr_rectangle_fill(x,y,w,h,c)	IgrRectangleFill((_xgc),(x),(y),(w),(h),(c))
#define	igr_comp_rectangle_fill(x,y,w,h)	IgrCompRectangleFill((_xgc),(x),(y),(w),(h))
#define	igr_rectangles(r,n,c)		IgrRectangles((_xgc),(r),(n),(c))
#define	igr_comp_rectangles(r,n)	IgrCompRectangles((_xgc),(r),(n))

#define	igr_rectangles_fill(r,n,c)		IgrRectanglesFill((_xgc),(r),(n),(c))
#define	igr_comp_rectangles_fill(r,n)	IgrCompRectanglesFill((_xgc),(r),(n))

/* quadrangular */
#define igr_quadrangular(p,c)		IgrQuadrangular((_xgc),(p),(c))
#define igr_comp_quadrangular(p)	IgrCompQuadrangular((_xgc),(p))
#define igr_quadrangular_fill(p,c)	IgrQuadrangularFill((_xgc),(p),(c))
#define igr_comp_quadrangular_fill(p)	IgrCompQuadrangularFill((_xgc),(p))

/* polygon */
#define igr_poly_line(p,n,c)		IgrPolyLine((_xgc),(p),(n),(c))
#define igr_comp_poly_line(p,n)		IgrCompPolyLine((_xgc),(p),(n))
#define igr_polygon(p,n,c)			IgrPolygon((_xgc),(p),(n),(c))
#define igr_comp_polygon(p,n)		IgrCompPolygon((_xgc),(p),(n))
#define igr_polygon_fill(p,n,c)		IgrPolygonFill((_xgc),(p),(n),(c))
#define igr_comp_polygon_fill(p,n)	IgrCompPolygonFill((_xgc),(p),(n))

/* arc */
#define	igr_circle(x,y,r,c)			IgrCircle((_xgc),(x),(y),(r),(c))
#define	igr_comp_circle(x,y,r)		IgrCompCircle((_xgc),(x),(y),(r))
#define	igr_circle_fill(x,y,r,c)	IgrCircleFill((_xgc),(x),(y),(r),(c))
#define	igr_comp_circle_fill(x,y,r)	IgrCompCircleFill((_xgc),(x),(y),(r))
#define	igr_circles(a,n,c)			IgrCircles((_xgc),(a),(n),(c))
#define	igr_comp_circles(a,n)		IgrCompCircles((_xgc),(a),(n))
#define	igr_circles_fill(a,n,c)		IgrCirclesFill((_xgc),(a),(n),(c))
#define	igr_comp_circles_fill(a,n)	IgrCompCirclesFill((_xgc),(a),(n))

#define	igr_arc(x,y,r,r1,r2,c)			IgrArc((_xgc),(x),(y),(r),(r1),(r2),(c))
#define	igr_comp_arc(x,y,r,r1,r2)		IgrCompArc((_xgc),(x),(y),(r),(r1),(r2))
#define	igr_arc_fill(x,y,r,r1,r2,c)	IgrArcFill((_xgc),(x),(y),(r),(r1),(r2),(c))
#define	igr_comp_arc_fill(x,y,r,r1,r2)	IgrCompArcFill((_xgc),(x),(y),(r),(r1),(r2))

/* text */
#define	igr_load_font(n)			IgrLoadFont((_xgc), (n))
#define	igr_unload_font()			IgrUnloadFont((_xgc))
#define	igr_text(x,y,s,c)			IgrText((_xgc), (x), (y), (s), (c))
#define	igr_text_ascent()			IgrTextAscent((_xgc))
#define	igr_text_descent()			IgrTextDescent((_xgc))
#define	igr_text_width(s)			IgrTextWidth((_xgc), (s))
#define	igr_text_extents(s,a,d,l,r,w)	IgrTextExtents((_xgc), (s), (a), (d), (l), (r), (w))

#define	igr_load_font16(n)			IgrLoadFont16((_xgc), (n))
#define	igr_unload_font16()			IgrUnloadFont16((_xgc))
#define	igr_text16(x,y,s,c)			IgrText16((_xgc), (x), (y), (s), (c))
#define	igr_text_ascent16()			IgrTextAscent16((_xgc))
#define	igr_text_descent16()		IgrTextDescent16((_xgc))
#define	igr_text_width16(s)			IgrTextWidth16((_xgc), (s))
#define	igr_text_extents16(s,a,d,l,r,w)	IgrTextExtents16((_xgc), (s), (a), (d), (l), (r), (w))

#define	igr_jis_text(x,y,s,c)		IgrJISText((_xgc), (x), (y), (s), (c))
#define	igr_jis_text_ascent()		IgrJISTextAscent((_xgc))
#define	igr_jis_text_descent()		IgrJISTextDescent((_xgc))
#define	igr_jis_text_width(s)		IgrJISTextWidth((_xgc), (s))
#define	igr_jis_text_extents(s,a,d,l,r,w)	IgrJISTextExtents((_xgc), (s), (a), (d), (l), (r), (w))

/* image */
#define igr_image_save(n)			IgrImageSave((_xgc), (n))
#define igr_image_get()				IgrImageGet((_xgc))
#define igr_image_put(x,y,i)		IgrImageGet((_xgc), (x), (y), (i))

#include	"pxlfont/pxlfont.h"

void	IgrTeX_printf		__P((IgrGC xgc, IgrVec *bp, int dir, TeX_font texfont, int v, const char *fmt, ...));
int	IgrTeX_printf_width		__P((IgrGC xgc, TeX_font texfont, const char *fmt, ...));
int	IgrTeX_printf_ascent		__P((IgrGC xgc, TeX_font texfont, const char *fmt, ...));
int	IgrTeX_printf_descent		__P((IgrGC xgc, TeX_font texfont, const char *fmt, ...));
void	IgrLine();
void	IgrRectangleFill();
void	IgrRectangle();
void	IgrDot();
void	IgrDots();
void	IgrBasePush();
void	IgrBasePop();
IgrGC	IgrClose();
int	image_save_png();

#endif	/* Igr_Inc_Defined */


