/*
$Header: /usr/staff/alex/edb/srcs/libedbpub/pxlfont/RCS/pxlfont.h,v 1.3 2004/03/30 13:05:53 alex Exp alex $
	pxlfont.h--- header file handling
	(C) Copyright 1990 by Sato Lab.
		Version 0.00 07-Jan-1990 by Alex
		Version 0.01 07-Jan-1990 by Alex
*/

#ifndef	Pxlfont_Inc_Defined
#define	Pxlfont_Inc_Defined

struct PXLINFO {
	int ChkSum;
	int Mag;
	int DgnSize;
	int DirPos;
	int IDtype;
};

struct FONTINFO {
	short int	Width;
	short int	Height;
	short int	Hoff;
	short int	Voff;
	int			Pos;
	int			TFMwidth;
};

struct PXLFONT {
	struct PXLINFO		info;
	int				nfonts;
	struct FONTINFO	*fontinfo;
	int				*fontdata;
};
typedef	struct PXLFONT *Pxlfont;

struct PXLFONT *pxlfont_load();
struct PXLFONT *pxlfont_free();

struct TEX_FONT {
#define PXL_RM			0
#define PXL_IT			1
#define PXL_SL			2
#define PXL_TT			3
#define PXL_MIT			4
#define PXL_CAL			5
#define PXL_EX			6
#define PXL_BF			7
#define	TEX_FONTs		8
	struct PXLFONT *normal[TEX_FONTs];
	struct PXLFONT *script[TEX_FONTs];
};
typedef	struct TEX_FONT *TeX_font;

struct TEX_FONT *texfont_load();
struct TEX_FONT *texfont_free();

struct TEX_CODE	{
	int fontset;
	int	code;
	int script;
#define	TEX_NO_SCRIPT	0
#define	TEX_UP_SCRIPT	1
#define	TEX_DOWN_SCRIPT	2
};
typedef	struct TEX_CODE	TeX_code;

#define	TEX_space		001000
#define	TEX_thin_space	001001
#define	TEX_thick_space	001002

#if 0
#define	TEX_alpha		'\013'
#define	TEX_beta		'\014'
#define	TEX_gamma		'\015'
#define	TEX_delta		'\016'
#define	TEX_epsilon		'\017'
#define	TEX_varepsilon	'\042'
#define	TEX_zeta		'\020'
#define	TEX_eta			'\021'
#define	TEX_theta		'\022'
#define	TEX_vartheta	'\043'
#define	TEX_iota		'\023'
#define	TEX_kappa		'\024'
#define	TEX_lambda		'\025'
#define	TEX_mu			'\026'
#define	TEX_nu			'\027'
#define	TEX_xi			'\030'
/* #define	TEX_o			'o' */
#define	TEX_pi			'\031'
#define	TEX_varpi		'\044'
#define	TEX_rho			'\032'
#define	TEX_varrho		'\045'
#define	TEX_sigma		'\033'
#define	TEX_varshigma	'\046'
#define	TEX_tau			'\034'
#define	TEX_upsilon		'\035'
#define	TEX_phi			'\036'
#define	TEX_varphi		'\047'
#define	TEX_chi			'\037'
#define	TEX_psi			'\040'
#define	TEX_omega		'\041'

#define	TEX_Gamma		'\000'
#define	TEX_Delta		'\001'
#define	TEX_Theta		'\002'
#define	TEX_Lambda		'\003'
#define	TEX_Xi			'\004'
#define	TEX_Pi			'\005'
#define	TEX_Sigma		'\006'
#define	TEX_Upsilon		'\007'
#define	TEX_Phi			'\010'
#define	TEX_Psi			'\011'
#define	TEX_Omega		'\012'


#define	TEX_aleph		'\100'
#define	TEX_hbar		'\000'
#define	TEX_imath		'\173'
#define	TEX_jmath		'\174'
/*#define	TEX_ell			'\000'*/
#define	TEX_wp			'\175'
#define	TEX_Re			'\075'
#define	TEX_Im			'\075'
#define	TEX_partial		'\100'
#define	TEX_infty		'\061'
#define	TEX_prime		'\060'
#define	TEX_emptyset	'\073'
#define	TEX_nabla		'\162'
#define	TEX_surd		'\160'
#define	TEX_top			'\076'
#define	TEX_bot			'\077'
#define	TEX_norm		'\153'
/*#define	TEX_angle		'\000'*/
#define	TEX_triangle	'\064'
#define	TEX_backslash	'\156'
#define	TEX_forall		'\070'
#define	TEX_exists		'\071'
#define	TEX_neg			'\072'
#define	TEX_flat		'\133'
#define	TEX_natural		'\134'
#define	TEX_sharp		'\135'
#define	TEX_clubsuit	'\174'
#define	TEX_diamondsuit	'\175'
#define	TEX_hartsuit	'\176'
#define	TEX_spadesuit	'\177'

#define	TEX_pm
#define	TEX_mp
#define	TEX_setminus
#define	TEX_cdot
#define	TEX_times
#define	TEX_ast
#define	TEX_star
#define	TEX_diamond
#define	TEX_circ
#define	TEX_bullet
#define	TEX_div
#define	TEX_cap
#define	TEX_cup
#define	TEX_uplus
#define	TEX_sqcap
#define	TEX_sqcup
#define	TEX_triangleleft
#define	TEX_triangleright
#define	TEX_wr
#define	TEX_bigcirc
#define	TEX_bigtriangleup
#define	TEX_bigtriangledown
#define	TEX_vee
#define	TEX_wedge
#define	TEX_oplus
#define	TEX_ominus
#define	TEX_otimes
#define	TEX_oslash
#define	TEX_odot
#define	TEX_dagger
#define	TEX_ddagger
#define	TEX_amalog

#define	TEX_leq
#define	TEX_prec
#define	TEX_preceq
#define	TEX_ll
#define	TEX_subset
#define	TEX_subseteq
#define	TEX_sqsubseteq
#define	TEX_in
#define	TEX_vdash
#define	TEX_simle
#define	TEX_frown
#define	TEX_geq
#define	TEX_succ
#define	TEX_succeq
#define	TEX_supset
#define	TEX_supseteq
#define	TEX_sqsupseteq
#define	TEX_ni
#define	TEX_dashv
#define	TEX_mid
#define	TEX_parallel
#define	TEX_equiv
#define	TEX_sim
#define	TEX_simeq
#define	TEX_asymp
#define	TEX_approx
#define	TEX_cong
#define	TEX_bowtie
#define	TEX_propto
#define	TEX_models
#define	TEX_doteq
#define	TEX_perp

#define	TEX_not

#define	TEX_leftarrow
#define	TEX_Leftarrow
#define	TEX_rightarrow
#define	TEX_Rightarrow
#define	TEX_leftrightarrow
#define	TEX_Leftrightarrow
#define	TEX_mapsto
#define	TEX_hookleftarrow
#define	TEX_leftharpoonup
#define	TEX_leftharpoondown
#define	TEX_rightleftharpoons
#define	TEX_longleftarrow
#define	TEX_Longleftarrow
#define	TEX_longrightarrow
#define	TEX_Longrightarrow
#define	TEX_longleftrightarrow
#define	TEX_Longleftrightarrow
#define	TEX_longmapsto
#define	TEX_hookrightarrow
#define	TEX_rightharpoonup
#define	TEX_rightharpoondown
#define	TEX_uparrow
#define	TEX_Uparrow
#define	TEX_downarrow
#define	TEX_Downarrow
#define	TEX_updownarrow
#define	TEX_Updownarrow
#define	TEX_nearrow
#define	TEX_searrow
#define	TEX_swarrow
#define	TEX_nwarrow
#endif

#ifndef TRUE
#define	TRUE		(1)
#endif

#ifndef	FALSE
#define	FALSE		(0)
#endif

#ifndef	ERROR
#define	ERROR		(-1)
#endif

#ifndef	NULL
#define	NULL		0
#endif

#define	STRLEN		(512)		/* maximum of string length */
#define	PATHLENGTH	(1024)		/* maximum of path length */

/***********************/
/* mathematical MACROs */
/***********************/
#define	min(x,y)	((x)<(y)?(x):(y))
#define	max(x,y)	((x)>(y)?(x):(y))
#define	abs(x)		((x)>=0 ?(x):(-(x)))
#define	sqr(x)		((x)*(x))
#define	sgn(x)		(((x)>0)?(1):(((x)<0)?(-1):(0)))

/**************************/
/* mathematical variables */
/**************************/
#define PI   3.14159265358979323846
#define PID2 1.57079632679489661923	/* PI divided by 2 */
#define PID4 0.78539816339744830962	/* PI divided by 4 */
#define I_PI 0.31830988618379067154	/* Inverse of PI */
#define I_PID2 0.63661977236758134308	/* Inverse of PID2 */

void	TeX_parse();

#endif	/* Pxlfont_Inc_Defined */
